﻿var zoom = ej.datavisualization.Diagram.Zoom();
var saveData = null;

//function MenuBarRender() {
//    //MenuBar
//    $("#DiagramMenuControl").ejMenu({ width: 612, click: "MenubarClick", openOnClick: false });
//};


//function ToolBarRender() {
//    $("#toolbarEvents").ejToolbar({
//        orientation: "horizontal",
//        create: "toolbarLoad",
//        click: "toolbarClick",
//        itemHover: "toolbarChecked",
//        itemLeave: "toolbarUnChecked"
//    });
//};
//$('#save_icon').ejButton({
//    showRoundedCorner: true,
//    size: ej.ButtonSize.Mini,
//});



function MenubarClick(sender) {
    var option = sender.events.text;
    var diagram = $("#DiagramContent").ejDiagram("instance");
    imgData = diagram.exportAsImage();
    if (!(option == "Align" || option == "Grouping" || option == "Order" || option == "Resize" || option == "File" || option == "Edit" || option == "View" || option == "Actions" || option == "Export as JPG" || option == "Export as PNG" || option == "Export as BMP" || option == "Export as SVG" || option == "Print" || option == "Save" || option == "Open" || option == "New"))
        diagram._modified = true;
    if (diagram._modified != true && option == "New") {
        diagram.clear();
        diagram._modified = false;
    }
    if (option == "Export as JPG") {
        var blob = dataURItoBlob(imgData, "jpg")
        saveAs(blob, "diagram.jpg");
    }
    if (option == "Export as PNG") {
        var blob = dataURItoBlob(imgData, "png")
        saveAs(blob, "diagram.png");
    }
    if (option == "Export as BMP") {
        var blob = dataURItoBlob(imgData, "bmp")
        saveAs(blob, "diagram.bmp");
    }
    if (option == "Export as SVG") {
        var div1 = document.createElement("div");
        div1.setAttribute("id", "export");
        div1.setAttribute("style", "display:none");
        document.body.appendChild(div1);
        var imgcollection = new Array();
        var _svg = document.createElementNS("http://www.w3.org/2000/svg", "svg");
        if (ej.browserInfo().name !== "msie") {
            _svg.setAttribute("xmlns", "http://www.w3.org/2000/svg");
        }
        _svg.setAttribute("id", "export_svg");
        _svg.setAttribute("style", "height:" + this._svgHeight + "; width:" + this._svgWidth + ";");
        _svg.setAttribute("version", "1.1");
        _svg.setAttribute("xlink", "http://www.w3.org/1999/xlink");
        div1.appendChild(_svg);
        var _tags = document.getElementById("DiagramContent_canvaspatterndefinition").cloneNode(true);
        var _printg = document.getElementById("DiagramContent_canvas_diagramLayer").cloneNode(true);
        _svg.appendChild(_printg);

        var _defs = document.getElementById("DiagramContent_canvaspatterndefinition").cloneNode(true);
        _defs.removeChild(_defs.firstChild);
        _svg.appendChild(_defs);

        imgData = div1.innerHTML;
        var blob = new Blob([imgData], { type: "text/plain;charset=utf-8" });
        saveAs(blob, "diagram.svg");
        //exportTo("svg");
    }
    if (option == "Print") { 
        diagram.print(); 
    }
    if (option == "Undo") {
        diagram.undo();
    }
    if (option == "Redo") {
        diagram.redo();
    }
    if (option == "Cut") {
        diagram.cut();
    }
    if (option == "Copy") {
        diagram.copy();
    }
    if (option == "Paste") {
        diagram.paste();
    }
    if (option == "Delete") {
        diagram.remove();
    }
    if (option == "Select All") {
        diagram.selectAll();
    }

    if (option == "Left") {
        diagram.align("left");
    }
    if (option == "Right") {
        diagram.align("right");
    }
    if (option == "Center") {
        diagram.align("center");
    }
    if (option == "Top") {
        diagram.align("top");
    }
    if (option == "Bottom") {
        diagram.align("bottom");
    }
    if (option == "Middle") {
        diagram.align("middle");
    }
    if (option == "Group") {
        diagram.group();
    }
    if (option == "Ungroup") {
        diagram.ungroup();
    }
    if (option == "Bring To Front") {
        diagram.bringToFront();
    }
    if (option == "Bring Forward") {
        diagram.moveForward();
    }
    if (option == "Send To Back") {
        diagram.sendToBack();
    }
    if (option == "Send Backward") {
        diagram.sendBackward();
    }
    if (option == "Same Size") {
        diagram.sameSize();
    }
    if (option == "Same Height") {
        diagram.sameHeight();
    }
    if (option == "Same Width") {
        diagram.sameWidth();
    }
    if (option == "Space Down") {
        diagram.spaceDown();
    }
    if (option == "Space Across") {
        diagram.spaceAcross();
    }
    if (option == "Grid Lines") {
        var snapSettings = diagram.model.snapSettings;
        var snapConstraints = snapSettings.snapConstraints ^ ej.datavisualization.Diagram.SnapConstraints.ShowLines;
        if (snapConstraints & ej.datavisualization.Diagram.SnapConstraints.ShowLines) {
            $("#GridLines").find("span").css("display", "block");
        }
        else {
            $("#GridLines").find("span").css("display", "none");
        }

        $("#DiagramContent").ejDiagram({ snapSettings: { snapConstraints: snapConstraints } });

    }
    if (option == "Snap To Grid") {
        var snapSettings = diagram.model.snapSettings;
        var snapConstraints = snapSettings.snapConstraints ^ ej.datavisualization.Diagram.SnapConstraints.SnapToLines;
        if (snapConstraints & ej.datavisualization.Diagram.SnapConstraints.SnapToLines) {
            $("#SnapToGrid").find("span").css("display", "block");
        }
        else {
            $("#SnapToGrid").find("span").css("display", "none");
        }
        $("#DiagramContent").ejDiagram({ snapSettings: { snapConstraints: snapConstraints } });

    }
    if (option == "Smart Guide") {
        if (diagram.model.snapSettings.enableSnapToObject)
        { diagram.model.snapSettings.enableSnapToObject = false; }
        else
        { diagram.model.snapSettings.enableSnapToObject = true; }

        if (diagram.model.snapSettings.enableSnapToObject) {
            $("#SmartGuid").find("span").css("display", "block");
        }
        else {
            $("#SmartGuid").find("span").css("display", "none");
        }
    }
    if (option == "Directed Tree") {

    }
    if (option == "Hierarchical Tree") {
        var layout = {
            "type": "hierarchicalTree",
            "orientation": "toptobottom",
            "horizontalSpacing": 50,
            "verticalSpacing": 60,
            "borderWidth": 2,
            "marginX": 30,
            "marginY": 30
        };
        diagram.setLayout(layout);
    }

    if (option == "Save") {
        if (!(window.loadFileName) && !(window.saveFileName)) {
            $("#basicDialog").ejDialog("open");
            $(".e-dialog-scroller e-scroller e-js e-widget").css("height", "130.6px");
            $("#SaveFileName").focus();
        }
        else if ((window.loadFileName) || (window.saveFileName)) {
            if (window.loadFileName)
                document.getElementById("SaveFileName").value = window.loadFileName;
            else if (window.saveFileName)
                document.getElementById("SaveFileName").value = window.saveFileName;
            saveFileAsString();
        }
    }
    if (option == "New") {
        if (diagram._modified == true) {
            $("#confirmDialog").ejDialog("open");
            $("#confirmDialog").focus();
        }
        window.loadFileName = null;
        window.saveFileName = null;
    }
    if (option == "Save As") {
        if (window.loadFileName)
            document.getElementById("SaveFileName").value = window.loadFileName;
        else if (window.saveFileName)
            document.getElementById("SaveFileName").value = window.saveFileName;
        $("#basicDialog").ejDialog("open");
        $("#SaveFileName").focus();
    }
    if (option == "Open") {
        var hasProperties = false;
        $.each(localStorage, function (key, value) {
            hasProperties = true;
        });
        if (hasProperties) {
            openDialogOpen();
            $("#FileOpenDialog").ejDialog("open");
            $("#FileOpenDialog").css("height", "350px");
            $("#FileOpenDialog").css("width", "350px");
        } else {
            alert("There is no saved diagram");
        }

    }
};
function new_No() {
    diagram.clear();
    $("#confirmDialog").ejDialog("close");
}
function openDialogOpen() {
    if (document.getElementById("FileTreeView")) {
        var root = document.getElementById("FileTreeView");
        root.innerHTML = "";
        $.each(localStorage, function (key, value) {
            try {
                var val = JSON.parse(localStorage.getItem(key));
                if (val) {
                    if (val.nodes || val.connectors || val.contextMenu) {
                        createLiForFileTree(key);
                    }
                }
            } catch (e) {

            }
        });
    }
}


function createLiForFileTree(key) {
    var root = document.getElementById("FileTreeView");
    var li = document.createElement("li");
    li.setAttribute("class", "e-item");
    li.setAttribute("tabindex", "-1");
    li.setAttribute("role", "treeitem");

    var div = document.createElement("div");
    div.setAttribute("class", "fileItemHover");
    div.setAttribute("id", key + "_hover");
    div.onclick = onFileItemSelect;
    div.setAttribute("role", "presentation");
    div.onmousemove = onMouseMove;

    div.onmouseout = onMouseOut;

    function onMouseMove(e) {
        var target;
        //if (e.target && e.target.className != "deleteIconfileItem") {
        if (e.target.localName == "a" || (e.target && e.target.className == "deleteIconfileItem"))
            target = e.target.parentNode;
        else
            target = document.getElementById(e.target.id);
        target.lastChild.style.display = "block";
        //}
    }

    function onMouseOut(e) {
        var target;
        //if (e.target && e.target.className != "deleteIconfileItem") {
        if (e.target.localName == "a" || (e.target && e.target.className == "deleteIconfileItem"))
            target = e.target.parentNode;
        else
            target = document.getElementById(e.target.id);
        target.lastChild.style.display = "none";
        //}
    }

    var childDiv = document.createElement("div");
    childDiv.setAttribute("role", "presentation");
    div.appendChild(childDiv);
    var span = document.createElement("span");
    span.setAttribute("class", "child");
    div.appendChild(span);
    var a = document.createElement("a");
    $(a).css("pointer-events", "none");
    a.setAttribute("class", "e-text CanSelect");
    $(a).css("margin-left", "19px");
    a.setAttribute("href", "#" + key + "_fileItem");
    a.innerHTML = key;
    div.appendChild(a);

    var checkbox = document.createElement("div");
    checkbox.setAttribute("class", "deleteIconfileItem");
    checkbox.setAttribute("style", "background-image: url('images/Close.png');background-repeat: no-repeat;float: right;height: 18px;margin-right: 12px;width: 20px;display:none;");
    checkbox.onclick = onFileDeleteClick;
    div.appendChild(checkbox);
    li.appendChild(div);
    root.appendChild(li);
}

function onFileDeleteClick(e) {
    var delItem = document.getElementById(e.target.previousSibling.innerHTML + "_hover");
    if (delItem) {

        var delParent = delItem.parentNode;
        if (delParent) {
            delParent.parentNode.removeChild(delParent);
            localStorage.removeItem(e.target.previousSibling.innerHTML);
        }

    }
}

function onFileItemSelect(e) {
    var target;
    if (e.target.localName == "a")
        target = e.target.parentNode;
    else
        target = document.getElementById(e.target.id);

    if (target) {
        if (window.selectedFileItemName != target.id) {
            $("#" + window.selectedFileItemName).removeClass("selected");
        }
        if (target) {
            $(target).addClass("selected");
            window.selectedFileItemName = target.id;
        }
    }

}

function onFileItemSelected(args) {
    var fileName = (window.selectedFileItemName).split("_")[0];
    $("#FileOpenDialog").ejDialog("close");
    if (fileName != null && fileName != "") {
        var diagram = $("#DiagramContent").ejDiagram("instance");
        var data = localStorage.getItem(fileName);
        if (data) {
            var jsonData = JSON.parse(data);
            diagram.load(jsonData);
            window.loadFileName = fileName;
        }
    }

}



function new_SaveFileAsString() {

    $("#confirmDialog").ejDialog("open");
    $("#confirmDialog").ejDialog("close");
    $("#basicDialog1").ejDialog("open");

    new_saveOptions();

}
function saveFileAsString() {
    saveOptions();
}
function saveIcon() {
    if (!(window.loadFileName) && !(window.saveFileName)) {
        $("#basicDialog").ejDialog("open");
        $(".e-dialog-scroller e-scroller e-js e-widget").css("height", "130.6px");
        $("#SaveFileName").focus();
    }
    else if ((window.loadFileName) || (window.saveFileName)) {
        if (window.loadFileName)
            document.getElementById("SaveFileName").value = window.loadFileName;
        else if (window.saveFileName)
            document.getElementById("SaveFileName").value = window.saveFileName;
        saveFileAsString();

    }
}

function saveOptions() {
    var res = "";
    var diagram = $("#DiagramContent").ejDiagram("instance");

    if (document.getElementById("SaveFileName").value) {
        try {
            res = document.getElementById("SaveFileName").value;
            saveData = diagram.save(res);
            $("#basicDialog").ejDialog("close");
            if (localStorage == undefined)
                alert("Your Browser Doesn't support this action.");
            else
                localStorage.setItem(res, JSON.stringify(saveData));
        }
        catch (e) {
        }

    }

    document.getElementById("SaveFileName").value = "";
    window.saveFileName = res;
    window.loadFileName = "";
}
function new_saveOptions() {
    var res = "";
    var diagram = $("#DiagramContent").ejDiagram("instance");
    if (document.getElementById("SaveFileName1").value) {

        try {
            res = document.getElementById("SaveFileName1").value;
            saveData = diagram.save(res);
            $("#basicDialog1").ejDialog("close");
            diagram.clear();
            if (localStorage == undefined)
                alert("Your Browser Doesn't support this action.");
            else
                localStorage.setItem(res, JSON.stringify(saveData));
        }

        catch (e) {
        }
    }

    document.getElementById("SaveFileName1").value = "";

    window.saveFileName = res;
    window.loadFileName = "";
}
function toolbarClick(sender) {
    var object;
    var nodes, i;
    var option = sender.currentTarget.id;
    var diagram = $("#DiagramContent").ejDiagram("instance");
    if (!(option == "Pan_Tool"))
        diagram._modified = true;
    if (option == "Redo_Tool") {
        diagram.redo();
    }
    if (option == "Undo_Tool") {
        diagram.undo();
    }
    if (option == "Delete_Tool") {
        diagram.remove();
    }

    if (option == "Actualsize_Tool") {
    }
    if (option == "ZoomIn_Tool") {
        var zoom1 = ej.datavisualization.Diagram.Zoom();
        zoom1.zoomFactor = 0.2;
        zoom1.zoomCommand = ej.datavisualization.Diagram.ZoomCommand.ZoomIn;
        diagram.zoomTo(zoom1);
        $("#overviewSlider").ejSlider('option', 'value', String(Math.round(diagram._getCurrentZoom() * 100)));
        $("#minSlider").ejSlider('option', 'value', String(Math.round(diagram._getCurrentZoom() * 100)));
        var sliderValue = document.getElementsByClassName("sliderValue");
        for (var i = 0; i < sliderValue.length; i++)
            sliderValue[i].textContent = String(Math.round(diagram._getCurrentZoom() * 100)) + "%";
        $('#zoompercentage').ejDropDownList("option", "value", String(Math.round(diagram._getCurrentZoom() * 100)) + "%");
    }
    if (option == "ZoomOut_Tool") {
        var zoom1 = ej.datavisualization.Diagram.Zoom();
        zoom1.zoomFactor = 0.2;
        zoom1.zoomCommand = ej.datavisualization.Diagram.ZoomCommand.ZoomOut;
        diagram.zoomTo(zoom1);
        $("#overviewSlider").ejSlider('option', 'value', String(Math.round(diagram._getCurrentZoom() * 100)));
        $("#minSlider").ejSlider('option', 'value', String(Math.round(diagram._getCurrentZoom() * 100)));
        var sliderValue = document.getElementsByClassName("sliderValue");
        for(var i=0;i<sliderValue.length;i++)
            sliderValue[i].textContent = String(Math.round(diagram._getCurrentZoom() * 100)) + "%";
        $('#zoompercentage').ejDropDownList("option", "value", String(Math.round(diagram._getCurrentZoom() * 100)) + "%");
    }
    if (option == "FitToPage_Tool") {
        diagram.fitToPage("page", "content", new ej.datavisualization.Diagram.Margin({ "left": 25, "top": 25, "right": 25, "bottom": 25 }));
        $("#overviewSlider").ejSlider('option', 'value', String(Math.round(diagram._getCurrentZoom() * 100)));
        $("#minSlider").ejSlider('option', 'value', String(Math.round(diagram._getCurrentZoom() * 100)));
        var sliderValue = document.getElementsByClassName("sliderValue");
        for (var i = 0; i < sliderValue.length; i++)
            sliderValue[i].textContent = String(Math.round(diagram._getCurrentZoom() * 100)) + "%";
        $('#zoompercentage').ejDropDownList("option", "value", String(Math.round(diagram._getCurrentZoom() * 100)) + "%");
    }
    if (option == "Pan_Tool") {
        $('#Pan_Tool').css('background-color', '#D3D1D1');
        ToolbarCommandEnabled(option);
    }
    if (option == "MoveTool_Tool") {
        $('#MoveTool_Tool').css('background-color', '#D3D1D1');
        ToolbarCommandEnabled(option);
        diagram.deactivateTool();
    }
    if (option == "Text_Tool") {
        $('#Text_Tool').css('background-color', '#D3D1D1');
        ToolbarCommandEnabled(option);
        diagram.activateTool("textTool");
    }
    if (option == "ConnectorDraw_Tool") {
        $('#ConnectorDraw_Tool').css('background-color', '#D3D1D1');
        ToolbarCommandEnabled(option);
        diagram._clearSelection();
        diagram.activateTool("orthogonalLine", false);
    }
    if (option == "ConnectorDraw_Tool_Straight") {
        $('#ConnectorDraw_Tool_Straight').css('background-color', '#D3D1D1');
        ToolbarCommandEnabled(option);
        diagram._clearSelection();
        diagram.activateTool("straightLine", false);
    }

    if (option == "Bold_Tool") {
        if (diagram.selectionList[0].isGroup) {
            if (diagram.selectionList[0].isPseudoGroup) {
                nodes = diagram.selectionList[0].children;
                for (i = 0; i < nodes.length; i++) {
                    object = new Object();
                    if (nodes[i].labels[0]) {
                        object.bold = !nodes[i].labels[0].bold;
                        diagram.setLabelFontStyle(nodes[i].name, object);
                    }
                }
            }
            else if (diagram.selectionList[0].labels[0]) {
                object = new Object();
                object.bold = !diagram.selectionList[0].labels[0].bold;
                diagram.setLabelFontStyle(diagram.selectionList[0].name, object);
            }
        }
        else if (diagram.selectionList.length == 1) {
            object = new Object();
            if (diagram.selectionList[0].labels[0])
                object.bold = !diagram.selectionList[0].labels[0].bold;
            diagram.setLabelFontStyle(diagram.selectionList[0].name, object);
        }
    }
    if (option == "Italic_Tool") {
        if (diagram.selectionList[0].isGroup) {
            if (diagram.selectionList[0].isPseudoGroup) {
                nodes = diagram.selectionList[0].children;
                for (i = 0; i < nodes.length; i++) {
                    object = new Object();
                    if (nodes[i].labels[0]) {
                        object.italic = !nodes[i].labels[0].italic;
                        diagram.setLabelFontStyle(nodes[i].name, object);
                    }
                }
            }
            else if (diagram.selectionList[0].labels[0]) {
                object = new Object();
                object.italic = !diagram.selectionList[0].labels[0].italic;
                diagram.setLabelFontStyle(diagram.selectionList[0].name, object);
            }
        }

        else if (diagram.selectionList.length == 1) {
            object = new Object();
            if (diagram.selectionList[0].labels[0])
                object.italic = !diagram.selectionList[0].labels[0].italic;
            diagram.setLabelFontStyle(diagram.selectionList[0].name, object);
        }
    }
    if (option == "Underline_Tool") {

        if (diagram.selectionList[0].isGroup) {
            if (diagram.selectionList[0].isPseudoGroup) {
                nodes = diagram.selectionList[0].children;
                for (i = 0; i < nodes.length; i++) {
                    object = new Object();
                    if (nodes[i].labels[0]) {
                        if (nodes[i].labels[0].textDecoration == "underline")
                            object.textDecoration = false;
                        else
                            object.textDecoration = true;
                        diagram.setLabelFontStyle(nodes[i].name, object);
                    }
                }
            }
            else if (diagram.selectionList[0].labels[0]) {
                object = new Object();
                if (diagram.selectionList[0].labels[0].textDecoration == "underline")
                    object.textDecoration = false;
                else
                    object.textDecoration = true;
                diagram.setLabelFontStyle(diagram.selectionList[0].name, object);
            }
        }

        else if (diagram.selectionList.length == 1) {
            object = new Object();
            if (diagram.selectionList[0].labels[0])
                if (diagram.selectionList[0].labels[0].textDecoration == "underline")
                    object.textDecoration = false;
                else
                    object.textDecoration = true;

            diagram.setLabelFontStyle(diagram.selectionList[0].name, object);
        }
    }

    if (option == "TailDecorator_Tool") {
    }

    if (option == "HeadDecorator_Tool") {
    }

    if (option == "LineConnector_Tool") {
    }
    if (option == "Drawing_Tool") {
    }

    if (option == "Color_Tool") {
        document.getElementById("spltbutton_Color_Tool_ul").style.visibility = "visible";
    }
    if (option == "Fill_Tool") {
        document.getElementById("spltbutton_Fill_Tool_ul").style.visibility = "visible";
    }
    if (option == "LineColor_Tool") {
        document.getElementById("spltbutton_LineColor_Tool_ul").style.visibility = "visible";
    }
    if (option == "Image_Tool") {
    }
    if (option == "Gradient_Tool") {
        document.getElementById("spltbutton_Gradient_Tool_ul").style.visibility = "visible";
    }
    if (option == "ZoomIn_Tool") {
    }
    if (option == "ZoomOut_Tool") {
    }
    if (option == "Pan_Tool") {
        diagram.activateTool("panTool")
    }
    if (option == "MoveTool_Tool") {
    }
    if (option == "LineConnector") {
    }
    if (option == "LineStart") {
    }
    if (option == "LineEnd") {
    }
    if (option == "SelectionArrow") {
    }
    if (option == "AlignLeft_Tool") {
        diagram.align("left");
    }
    if (option == "AlignCenter_Tool") {
        diagram.align("center");
    }
    if (option == "AlignRight_Tool") {
        diagram.align("right");
    }
    if (option == "AlignBottom_Tool") {
        diagram.align("bottom");
    }
    if (option == "AlignMiddle_Tool") {
        diagram.align("middle");
    }
    if (option == "AlignTop_Tool") {
        diagram.align("top");
    }
    if (option == "Group_Tool") {
        diagram.group();
    }
    if (option == "UnGroup_Tool") {
        diagram.ungroup();
    }
    if (option == "SendToBack_Tool") {
        diagram.sendToBack();
    }
    if (option == "MoveForward_Tool") {
        diagram.moveForward();
    }
    if (option == "SendBackward_Tool") {
        diagram.sendBackward();
    }
    if (option == "BringToFront_Tool") {
        diagram.bringToFront();
    }
    if (option == "Lock_Tool") {
        ko.applyBindings(diagram._selectedObject.method({}, "Lock"));
    }
}

function ToolBarMouseOver(li) {
    if (li.classList[0] != "artboardtitle") {
        var x = li.style.backgroundColor;
        if ((x != "rgb(211, 209, 209)")) {
            if (x != "#D3D1D1") {
                li.style.backgroundColor = "#EAEAEA";
                li.style.border = "1px solid #808080";
            }
        }
    }
}

function ToolBarMouseOut(li) {
    ////if (li.style.backgroundColor == "#DDDDDD" || li.style.backgroundColor=="rgb(221,221,221)")
    if (li.classList[0] != "artboardtitle") {
        var x = li.style.backgroundColor;
        if ((x != "#D3D1D1")) {
            if (x != "rgb(211, 209, 209)") {
                li.style.backgroundColor = "#F7F5F5";
            }
            else {
                li.style.backgroundColor = "#D3D1D1";
            }

        }
        else
            li.style.backgroundColor = "#D3D1D1";

        li.style.border = "1px solid transparent";
    }
}


function ToolBarVisibility(args) {

    if (args == "ej.Diagram") {
        document.getElementById("toolblock4").style.display = "none";
        document.getElementById("toolblock5").style.display = "none";
        document.getElementById("toolblock6").style.display = "none";
        document.getElementById("Ul1").style.display = "none";
        document.getElementById("Ul2").style.display = "none";
        document.getElementById("artboard").style.display = "block";
    }
    if (args == "Single") {
        document.getElementById("toolblock4").style.display = "block";
        document.getElementById("toolblock5").style.display = "none";
        document.getElementById("toolblock6").style.display = "none";
        document.getElementById("Ul1").style.display = "block";
        document.getElementById("artboard").style.display = "none";
    }
    if (args == "Multi") {
        document.getElementById("toolblock4").style.display = "block";
        document.getElementById("toolblock5").style.display = "block";
        document.getElementById("toolblock6").style.display = "block";
        document.getElementById("Ul1").style.display = "none";
        document.getElementById("artboard").style.display = "none";
    }
    if (args == "Group") {
        document.getElementById("Ul1").style.display = "block";
        document.getElementById("Ul2").style.display = "block";
        document.getElementById("toolblock5").style.display = "none";
        document.getElementById("toolblock6").style.display = "none";
        document.getElementById("artboard").style.display = "none";
    }
}

function ToolbarCommandEnabled(id) {
    if (id != "Pan_Tool") {
        $('#Pan_Tool').css('background-color', '#F7F5F5');
    }
    if (id != "MoveTool_Tool") {
        $('#MoveTool_Tool').css('background-color', '#F7F5F5');
    }
    if (id != "Text_Tool") {
        $('#Text_Tool').css('background-color', '#F7F5F5');
    }
    if (id != "ConnectorDraw_Tool") {
        $('#ConnectorDraw_Tool').css('background-color', '#F7F5F5');
    }
    if (id != "ConnectorDraw_Tool_Straight") {
        $('#ConnectorDraw_Tool_Straight').css('background-color', '#F7F5F5');
    }
    if (id != "Image_Tool") {
        $('#Image_Tool').css('background-color', '#F7F5F5');
    }
}

function dataURItoBlob(imgData, imgType) {
    var binary = atob(imgData.split(',')[1]), array = [];
    for (var i = 0; i < binary.length; i++) array.push(binary.charCodeAt(i));
    return new Blob([new Uint8Array(array)], { type: imgType });
}

function saveFileAsString() {
    saveOptions();
}
function saveOptions() {
    var res = "";
    var diagram = $("#DiagramContent").ejDiagram("instance");

    if (document.getElementById("SaveFileName").value) {
        try {
            res = document.getElementById("SaveFileName").value;
            saveData = diagram.save(res);
            $("#basicDialog").ejDialog("close");
            if (localStorage == undefined)
                alert("Your Browser Doesn't support this action.");
            else
                localStorage.setItem(res, JSON.stringify(saveData));
        }
        catch (e) {
        }

    }

    document.getElementById("SaveFileName").value = "";
    window.saveFileName = res;
    window.loadFileName = "";

}
function new_saveOptions() {
    var res = "";
    var diagram = $("#DiagramContent").ejDiagram("instance");
    if (document.getElementById("SaveFileName1").value) {

        try {
            res = document.getElementById("SaveFileName1").value;
            saveData = diagram.save(res);
            $("#basicDialog1").ejDialog("close");
            diagram.clear();
            if (localStorage == undefined)
                alert("Your Browser Doesn't support this action.");
            else
                localStorage.setItem(res, JSON.stringify(saveData));
        }

        catch (e) {
        }
    }

    document.getElementById("SaveFileName1").value = "";

    window.saveFileName = res;
    window.loadFileName = "";
}