﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.DataVisualization.DiagramEnums;
using Syncfusion.JavaScript.DataVisualization.Models.Diagram;
using Syncfusion.JavaScript.DataVisualization.Models;
using System.Web.Script.Serialization;
using Syncfusion.JavaScript.DataVisualization.Models.Collections;
using Label = Syncfusion.JavaScript.DataVisualization.Models.Diagram.Label;
using MvcApplication69.Controllers;

namespace MvcApplication69
{
    public partial class DiagramController : Controller
    {
        //
        // GET: /Diagram/
        public ActionResult DiagramFeatures()
        {
            OverviewProperties overview = new OverviewProperties();
            overview.Height = "158px";
            overview.Width = "253px";
            overview.SourceID = "DiagramContent";
            DiagramBuilderModel diagramModel = new DiagramBuilderModel();
            SymbolPaletteProperties symbolpalette = new SymbolPaletteProperties();
            diagramModel.Palette(symbolpalette);
            diagramModel.Model.Tool = Tool.SingleSelect | Tool.ZoomPan;
            diagramModel.GenerateBasicShapes(symbolpalette);
            diagramModel.GenerateFlowShapes(symbolpalette);
            diagramModel.GenerateArrowShapes(symbolpalette);
            diagramModel.GenerateElectricalShapes(symbolpalette);
            diagramModel.GenerateBpmnShapes(symbolpalette);
            diagramModel.GenerateConnectors(symbolpalette);
            diagramModel.GenerateSwimLanes(symbolpalette);
            ViewData["DiagramModel"] = diagramModel.Model;
            ViewData["overview"] = overview;
            ViewData["SymbolPaletteModel"] = symbolpalette;
            return View();
        }
    }
}
