﻿var symbolPalette = null;
var expand = false;
var paletteCollection = [];
var previewPaletteCollection = [];
var showMinimizedPalette = false;
var pPanelOpen = false;
var isPMinized = false;
var diagram;
var oldratio;
var pageBackgroundColor = null;
$(window).load(function () {
    diagram = $("#DiagramContent").ejDiagram("instance");
    var userHandles = [];
    createUserHandles(userHandles);
    diagram.model.userHandles = userHandles;
    diagram.model.drawingTools = { textTool: ej.datavisualization.Diagram.TextTool() };
    diagram._registerDrawingTools();
    diagram._initHandles();
    diagram.model.selectionChange = selectionchanged;
    diagram.model.drop = nodeondrop;
    diagram.model.nodeCollectionChange = nodecollectionchanged;
    diagram.model.sizeChange = nodeSizeChanging;
    diagram.model.connectorCollectionChange = connectorcollectionChanged;
    diagram.model.textChange = textChanged;
    diagram.model.drag = nodeDragging;

    var gridline = { "snapInterval": [10] };
    $("#DiagramContent").ejDiagram({
        pageSettings: { pageHeight: 1100, pageWidth: 1200, showPageBreak: false, multiplePage: true },
        snapSettings: { horizontalGridLines: gridline, verticalGridLines: gridline },
    });

});
$(window).load(function () {
    $("body").css("font-family", "sans-serif");
    var width = $(document).width() - $("#main-left").width();
    $("#main-right").css("width", width);
    var pixels = document.getElementById("sample-header").getBoundingClientRect().height;
    var screenHeight = document.body.clientHeight;

    document.getElementById("sample-main").style.height = (screenHeight - pixels) - 20 + "px";
    var diagram = $("#DiagramContent").ejDiagram("instance");
    diagram.updateViewPort();
    oldratio = this.devicePixelRatio;
    var paletteItems = $(".e-paletteItem");
    for (m = 0; m < paletteItems.length; m++) {
        var title = "";
        var wWord = ((paletteItems[m].id).split("_")[0]);
        if (wWord) {
            if (wWord.split(/(?=[A-Z])/)[0])
                title += " " + wWord.split(/(?=[A-Z])/)[0];
            if (wWord.split(/(?=[A-Z])/)[1])
                title += " " + wWord.split(/(?=[A-Z])/)[1];
            if (wWord.split(/(?=[A-Z])/)[2])
                title += " " + wWord.split(/(?=[A-Z])/)[2];
            if (wWord.split(/(?=[A-Z])/)[3])
                title += " " + wWord.split(/(?=[A-Z])/)[3];
            if (wWord.split(/(?=[A-Z])/)[4])
                title += " " + wWord.split(/(?=[A-Z])/)[4];
        }
        paletteItems[m].setAttribute("title", title);
    }
    setPaletteCollections();
    var palette = $("#SymbolPalette").ejSymbolPalette("instance");
    var overview = $("#Overview").ejOverview("instance");
    overview._setParent("DiagramContent");
    $("#artBoardWidth").ejNumericTextbox({ name: "artBoardWidth", value: diagram.model.pageSettings.pageWidth, width: "75px", focusOut: "setDiagramWidth" });
    $("#artBoardHeight").ejNumericTextbox({ name: "artBoardHeight", value: diagram.model.pageSettings.pageHeight, width: "75px", focusOut: "setDiagramHeight" });
    $('#pageBackgroundColor').ejDropDownList({
        targetID: "pageBackgroundColorDiv",
        width: "360px",
        popupHeight: "180px",
    });
    document.getElementById("maxi_Search").style.backgroundColor = "white";
    setDiagramSize();
    var height = $("#main-left").height() - $(".searchicon-parent-div1").height() - $("#overview-div1").height() - 2;
    palette.setHeight(height + "px");
    palette.updateScrollerViewport();
    document.getElementById("backgroundIcon").style.color = diagram.model.pageSettings.pageBackgroundColor;
    document.getElementById("Overview-div").style.display = "none";
    diagram.updateViewPort();



    if (document.getElementById("DiagramContent_contextMenu_grouping")) {
        $("#DiagramContent_contextMenu_grouping").hover(function () {
            document.getElementById("DiagramContent_contextMenu_grouping").childNodes[1].style.color = "White";
        });
        $("#DiagramContent_contextMenu_grouping").mouseleave(function () {
            document.getElementById("DiagramContent_contextMenu_grouping").childNodes[1].style.color = "#5C5C5C";
        });
        document.getElementById("DiagramContent_contextMenu_grouping").childNodes[1].style.visibility = "visible";
        document.getElementById("DiagramContent_contextMenu_grouping").childNodes[1].style.color = "#5C5C5C";

        $("#DiagramContent_contextMenu_order").hover(function () {
            document.getElementById("DiagramContent_contextMenu_order").childNodes[1].style.color = "White";
        });
        $("#DiagramContent_contextMenu_order").mouseleave(function () {
            document.getElementById("DiagramContent_contextMenu_order").childNodes[1].style.color = "#5C5C5C";
        });
        document.getElementById("DiagramContent_contextMenu_order").childNodes[1].style.visibility = "visible";
        document.getElementById("DiagramContent_contextMenu_order").childNodes[1].style.color = "#5C5C5C";

        document.getElementById("DiagramContent_contextMenu_group").style.backgroundColor = "#ECEDEE";
        document.getElementById("DiagramContent_contextMenu_ungroup").style.backgroundColor = "#ECEDEE";
        document.getElementById("DiagramContent_contextMenu_bringToFront").style.backgroundColor = "#ECEDEE";
        document.getElementById("DiagramContent_contextMenu_sendToBack").style.backgroundColor = "#ECEDEE";
        document.getElementById("DiagramContent_contextMenu_moveForward").style.backgroundColor = "#ECEDEE";
        document.getElementById("DiagramContent_contextMenu_sendBackward").style.backgroundColor = "#ECEDEE";


        $("#DiagramContent_contextMenu_group").hover(function () {
            document.getElementById("DiagramContent_contextMenu_group").style.backgroundColor = "#229499";
            document.getElementById("DiagramContent_contextMenu_grouping").childNodes[1].style.color = "white";
        });
        $("#DiagramContent_contextMenu_ungroup").hover(function () {
            document.getElementById("DiagramContent_contextMenu_ungroup").style.backgroundColor = "#229499";
            document.getElementById("DiagramContent_contextMenu_grouping").childNodes[1].style.color = "white";
        });
        $("#DiagramContent_contextMenu_group").mouseleave(function () {
            document.getElementById("DiagramContent_contextMenu_group").style.backgroundColor = "transparent";
            document.getElementById("DiagramContent_contextMenu_grouping").childNodes[1].style.color = "#5C5C5C";
        });
        $("#DiagramContent_contextMenu_ungroup").mouseleave(function () {
            document.getElementById("DiagramContent_contextMenu_ungroup").style.backgroundColor = "transparent";
            document.getElementById("DiagramContent_contextMenu_grouping").childNodes[1].style.color = "#5C5C5C";
        });


        $("#DiagramContent_contextMenu_bringToFront").hover(function () {
            document.getElementById("DiagramContent_contextMenu_bringToFront").style.backgroundColor = "#229499";
            document.getElementById("DiagramContent_contextMenu_order").childNodes[1].style.color = "white";
        });
        $("#DiagramContent_contextMenu_sendToBack").hover(function () {
            document.getElementById("DiagramContent_contextMenu_sendToBack").style.backgroundColor = "#229499";
            document.getElementById("DiagramContent_contextMenu_order").childNodes[1].style.color = "white";
        });

        $("#DiagramContent_contextMenu_moveForward").hover(function () {
            document.getElementById("DiagramContent_contextMenu_moveForward").style.backgroundColor = "#229499";
            document.getElementById("DiagramContent_contextMenu_order").childNodes[1].style.color = "white";
        });
        $("#DiagramContent_contextMenu_sendBackward").hover(function () {
            document.getElementById("DiagramContent_contextMenu_sendBackward").style.backgroundColor = "#229499";
            document.getElementById("DiagramContent_contextMenu_order").childNodes[1].style.color = "white";
        });


        $("#DiagramContent_contextMenu_bringToFront").mouseleave(function () {
            document.getElementById("DiagramContent_contextMenu_bringToFront").style.backgroundColor = "transparent";
            document.getElementById("DiagramContent_contextMenu_order").childNodes[1].style.color = "#5C5C5C";
        });
        $("#DiagramContent_contextMenu_sendToBack").mouseleave(function () {
            document.getElementById("DiagramContent_contextMenu_sendToBack").style.backgroundColor = "transparent";
            document.getElementById("DiagramContent_contextMenu_order").childNodes[1].style.color = "#5C5C5C";
        });

        $("#DiagramContent_contextMenu_moveForward").mouseleave(function () {
            document.getElementById("DiagramContent_contextMenu_moveForward").style.backgroundColor = "transparent";
            document.getElementById("DiagramContent_contextMenu_order").childNodes[1].style.color = "#5C5C5C";
        });
        $("#DiagramContent_contextMenu_sendBackward").mouseleave(function () {
            document.getElementById("DiagramContent_contextMenu_sendBackward").style.backgroundColor = "transparent";
            document.getElementById("DiagramContent_contextMenu_order").childNodes[1].style.color = "#5C5C5C";
        });
    }
    $("#menu-file")[0].firstElementChild.style.color = "white";
    $("#menu-edit")[0].firstElementChild.style.color = "white";
    $("#menu-view")[0].firstElementChild.style.color = "white";
    $("#menu-action")[0].firstElementChild.style.color = "white";

});
$(window).keydown(function (e) {
    if (e.keyCode == 13) {
        if (!this.diagram._isEditing && this.diagram.selectionList.length > 0) {
            var node = this.diagram.selectionList[0];
            diagram.startLabelEdit(node, node.labels[0]);
            this.diagram._isEditing = true;
            e.originalEvent.preventDefault();
        }
    }
    //Group
    if (e.ctrlKey && e.keyCode == 71) {
        e.originalEvent.preventDefault();
        diagram.group();
    }
    //UnGroup
    if (e.ctrlKey && e.keyCode == 85) {
        e.originalEvent.preventDefault();
        diagram.ungroup();
    }
    //Bring to Front
    if (e.ctrlKey && e.keyCode == 70) {
        e.originalEvent.preventDefault();
        diagram.bringToFront();
    }
    //Send to Back
    if (e.ctrlKey && e.keyCode == 66) {
        e.originalEvent.preventDefault();
        diagram.sendToBack();
    }
});
$(window).resize(function () {
    var width = $(document).width() - $("#main-left").width();
    $("#main-right").css("width", width);
    var pixels = document.getElementById("sample-header").getBoundingClientRect().height;
    var screenHeight = document.body.clientHeight;
    document.getElementById("sample-main").style.height = (screenHeight - pixels) - 2 + "px";
    var diagram = $("#DiagramContent").ejDiagram("instance");
    setDiagramSize(diagram._selectedObject.pinned);
    var palette = $("#SymbolPalette").ejSymbolPalette("instance");
    var height = $("#main-left").height() - $(".searchicon-parent-div1").height() - $("#overview-div1").height() - 20;
    palette.setHeight(height + "px");
    palette.updateScrollerViewport();
});
function selectionchanged(args) {

    // $('#main-right').css('width', '63%');---------------------
    var diagram = $("#DiagramContent").ejDiagram("instance");
    if (!diagram._selectedObject) {
        diagram._selectedObject = new SelectorVMClass();
    }

    if (args.changeType != "remove") {
        if (args.element.isPseudoGroup) {
            $(".toolblock3rightBorderVisible").css({ "border-right": "1px solid #7F7F7F" });
            $(".toolblock5rightBorderVisible").css({ "border-right": "1px solid #7F7F7F" });
            ToolBarVisibility("Multi");
        }
        else if (args.element.shape || diagram.selectionList[0].segments || diagram.selectionList[0].isGroup) {
            $(".toolblock3rightBorderVisible").css({ "border-right": "1px solid #7F7F7F" });
            $(".toolblock5rightBorderVisible").css({ "border-right": "none" });
            $(".Ul1rightBorderVisible").css({ "border-right": "none" });
            ToolBarVisibility("Single");
            if (args.element.segments) {
                //document.getElementById("propertyEditor").style.display = "block";
                $("#tabitems").ejTab("option", "selectedItemIndex", 3);
            }
            if (args.element.isGroup) {
                $(".Ul2rightBorderVisible").css({ "border-right": "1px solid #7F7F7F" });
                ToolBarVisibility("Group");
            }
        }
        ko.applyBindings(diagram._selectedObject.select());
    }
    else {
        $(".toolblock5rightBorderVisible").css({ "border-right": "none" });
        $(".toolblock3rightBorderVisible").css({ "border-right": "none" });
        ToolBarVisibility("ej.Diagram");
        if (!diagram._selectedObject.pinned) {
            document.getElementById("propertyEditor").style.display = "none";
        }
        if (diagram.selectionList.length == 0)
            ko.applyBindings(diagram._selectedObject.select());
    }
    setDiagramSize(diagram._selectedObject.pinned);



    //#region toolbar options
    if (args.changeType != "remove") {

        if (!(args.element.isPseudoGroup)) {
            $("#toolbarEvents").ejToolbar("enableItemByID", "Group_Tool");
            $("#toolbarEvents").ejToolbar("enableItemByID", "UnGroup_Tool");
            $("#toolbarEvents").ejToolbar("enableItemByID", "SendToBack_Tool");
            $("#toolbarEvents").ejToolbar("enableItemByID", "MoveForward_Tool");
            $("#toolbarEvents").ejToolbar("enableItemByID", "SendBackward_Tool");
            $("#toolbarEvents").ejToolbar("enableItemByID", "BringToFront_Tool");
            if (args.element.children && args.element.children.length > 0) {
                $("#toolbarEvents").ejToolbar("disableItemByID", "Group_Tool");
                $("#toolbarEvents").ejToolbar("enableItemByID", "UnGroup_Tool");
            } else {
                $("#toolbarEvents").ejToolbar("disableItemByID", "Group_Tool");
                $("#toolbarEvents").ejToolbar("disableItemByID", "UnGroup_Tool");
            }
        }
        else {
            $("#toolbarEvents").ejToolbar("disableItemByID", "UnGroup_Tool");
            $("#toolbarEvents").ejToolbar("enableItemByID", "Group_Tool");
            $("#toolbarEvents").ejToolbar("disableItemByID", "SendToBack_Tool");
            $("#toolbarEvents").ejToolbar("disableItemByID", "MoveForward_Tool");
            $("#toolbarEvents").ejToolbar("disableItemByID", "SendBackward_Tool");
            $("#toolbarEvents").ejToolbar("disableItemByID", "BringToFront_Tool");
        }
    }
    //#endregion

    if (args.changeType != "remove") {
        var handles = diagram.model.userHandles;
        if (handles) {
            for (var i = 0; i < handles.length; i++) {
                if (handles[i].name == "Label") {
                    if (args.element.shape) {
                        if (args.element.shape.type == "text") {
                            handles[i].visible = true;
                        } else {
                            if (args.element.labels.length > 0) {
                                for (var j = 0; j < args.element.labels.length; j++) {
                                    if (args.element.labels[j].text.length == 0) {
                                        handles[i].visible = false;
                                    } else
                                        handles[i].visible = true;
                                }
                            } else
                                handles[i].visible = false;
                        }
                    } else if (args.element.isPseudoGroup || args.element.isGroup) {
                            labelHandlerExit:
                            for (var n = 0; n < args.element.children.length; n++) {
                                var child = diagram.nameTable[args.element.children[n]];
                                if (child.shape) {
                                    if (child.labels.length > 0) {
                                        for (var j = 0; j < child.labels.length; j++) {
                                            if (child.labels[j].text.length > 0) {
                                                handles[i].visible = true;
                                                break labelHandlerExit;
                                            } else
                                                handles[i].visible = false;
                                        }
                                    } else
                                        handles[i].visible = false;
                                }
                            }
                    }
                } else if (handles[i].name == "Line") {
                    if (args.element.shape) {
                        if (args.element.shape.type == "text") {
                            handles[i].visible = false;
                        } else
                            handles[i].visible = true;
                    }
                    else if (args.element.isGroup) {
                        handles[i].visible = false;
                    }
                } else
                    handles[i].visible = true;
            }
            if (args.element && args.element.segments) {
                for (var i = 0; i < handles.length; i++) {
                    if (handles[i].name != "Settings")
                        handles[i].visible = false;
                }
            }
            diagram.updateUserHandles(args.element);
        }
        if (args.elementType == "connector" || args.element.shape.type == "text") {
            var target = $("#opacity").data("ejSlider");
            target.disable();
        }
        else {
            target = $("#opacity").data("ejSlider");
            target.enable();
        }
    }
}

function nodeondrop(args) {
    var node = args.element;
    if (node.segments) {
        node.lineWidth = 2;
    }
    node.width = 100;
    node.height = 100;

    if (node && node.name) {
        var str = node.name.toString();
        if (str.match("5star")) {
            var points = _renderStar(node, 5, 25);
            node.shape = { type: "path", pathData: points };

        }
        else if (str.match("16star")) {
            var points = _renderStar(node, 16, 25);
            node.shape = { type: "path", pathData: points };

        }
        else if (str.match("6star")) {
            var points = _renderStar(node, 6, 25);
            node.shape = { type: "path", pathData: points };

        }
        else if (str.match("LeftArrow") && !str.match("CurvedLeftArrow") && !str.match("JumpingLeftArrow")) {

            var points = _renderLeftArrow(node);
            node.shape = { type: "path", pathData: points };

        }
        else if (str.match("RightArrow") && !str.match("CurvedRightArrow") && !str.match("JumpingRightArrow")) {

            var points = _renderRightArrow(node);
            node.shape = { type: "path", pathData: points };

        } else if (str.match("Parallelogram")) {

            var points = _renderParallelogram(node);
            node.shape = { type: "path", pathData: points };

        }
        else if (str.match("bendsingleArrow")) {

            var points = _renderBendSingleArrow(node);
            node.shape = { type: "path", pathData: points };

        }
        else if (str.match("benddoubleArrow")) {

            var points = _renderBenddoubleArrow(node);
            node.shape = { type: "path", pathData: points };

        }
        else if (str.match("DoubleArrow")) {
            node.width = 120;
            node.height = 60;
            var points = _renderDoubleArrow(node);
            node.shape = { type: "path", pathData: points };

        }
        else if (str.match("Column")) {
            var points = _renderGridColumn(node);
            node.shape = { type: "path", pathData: points };
        }
        else if (str.match("Row")) {
            var points = _renderGridRow(node);
            node.shape = { type: "path", pathData: points };

        }
        else if (str.match("Hexagon")) {
            var points = _renderOctagon(node);
            node.shape = { type: "path", pathData: points };

        }
        else if (str.match("CircularArrow") || str.match("CurvedUpArrow") || str.match("CurvedDownArrow")) {
            node.width = 120;
            node.height = 60;
        }
        else if (str.match("CurvedRightArrow") || str.match("CurvedLeftArrow")) {
            node.width = 60;
            node.height = 120;
        }

        if (typeof node.labels.length == "undefined" || node.labels.length == 0) {
            node.labels.push({ mode: ej.datavisualization.Diagram.LabelEditMode.Edit });
        }
        else if (node.labels.length != "undefined" && node.labels.length > 0) {
            node.labels[0].mode = ej.datavisualization.Diagram.LabelEditMode.Edit;
        }

        diagram = $("#DiagramContent").ejDiagram("instance");
        diagram.deactivateTool();
        $('#MoveTool_Tool').css('background-color', '#D3D1D1');
        $('#Pan_Tool').css('background-color', '#F7F5F5');
        $('#Text_Tool').css('background-color', '#F7F5F5');
        $('#ConnectorDraw_Tool').css('background-color', '#F7F5F5');
        $('#ConnectorDraw_Tool_Straight').css('background-color', '#F7F5F5');
        $('#Image_Tool').css('background-color', '#F7F5F5');
    }

}

function nodeSizeChanging(args) {
    
    updateIntelligentNode(args);
    if (args.element) {
        var diagram = $("#DiagramContent").ejDiagram("instance");
        diagram._modified = true;
        if (args.element.isPseudoGroup) {
            for (var n = 0; n < args.element.children.length; n++) {
                var child = diagram.nameTable[args.element.children[n]];
                if (child.shape) {
                    diagram._selectedObject.nodeSizeChanging(child);
                }
            }
        }
        else if (args.element.shape)
            diagram._selectedObject.nodeSizeChanging(args.element);
    }

}

function nodeDragging(args) {
    if (args.element.shape) {
        diagram._modified = true;
        diagram._selectedObject.nodeDragging(args.element);
    }
    else if (args.element.isPseudoGroup) {
        for (var n = 0; n < args.element.children.length; n++) {
            var element = diagram.nameTable[args.element.children[n]];
            if (element.shape) {
                diagram._selectedObject.nodeDragging(element);
            }
        }
    }
}

function nodecollectionchanged(args) {
    diagram._modified = true;
    if (args.changeType == "insert") {
        
        if (args.element.constraints & ej.datavisualization.Diagram.NodeConstraints.Connect) {
            args.element.constraints = ej.datavisualization.Diagram.NodeConstraints.Default ^ ej.datavisualization.Diagram.NodeConstraints.Connect;

            if (args.element.shape) {
                if (args.element.shape.type == "text") {
                    if (args.element.height < 35) {
                        args.element.height = 35;
                    }
                    args.element.fillColor = "Transparent";
                }
            }
        }
        updateIntelligentNode(args);
    }
}
function connectorcollectionChanged(args) {
    diagram._modified = true;
    if (args.changeType == "insert") {
        
        if (args.element.line) {
            if (args.element.lineWidth < 2) {
                args.element.lineWidth = 2;
            }

        }
    }
}

function textChanged(args) {
    diagram._modified = true;
    for (var i = 0; i < args.element.labels.length; i++) {
        if (args.element.segments) {
            args.element.labels[i].fillColor = "white";
        }
        args.element.labels[i].bold = false;
    }
}

$(window).load(function () {
    $("body").css("font-family", "sans-serif");
    var width = $(document).width() - $("#main-left").width();
    $("#main-right").css("width", width);



    var pixels = document.getElementById("sample-header").getBoundingClientRect().height;
    var screenHeight = document.body.clientHeight;

    document.getElementById("sample-main").style.height = (screenHeight - pixels) - 2 + "px";

    var diagram = $("#DiagramContent").ejDiagram("instance");
    diagram.updateViewPort();
    oldratio = this.devicePixelRatio;
    var paletteItems = $(".e-paletteItem");

    for (m = 0; m < paletteItems.length; m++) {
        var title = "";
        var wWord = ((paletteItems[m].id).split("_")[0]);
        if (wWord) {
            if (wWord.split(/(?=[A-Z])/)[0])
                title += " " + wWord.split(/(?=[A-Z])/)[0];
            if (wWord.split(/(?=[A-Z])/)[1])
                title += " " + wWord.split(/(?=[A-Z])/)[1];
            if (wWord.split(/(?=[A-Z])/)[2])
                title += " " + wWord.split(/(?=[A-Z])/)[2];
            if (wWord.split(/(?=[A-Z])/)[3])
                title += " " + wWord.split(/(?=[A-Z])/)[3];
            if (wWord.split(/(?=[A-Z])/)[4])
                title += " " + wWord.split(/(?=[A-Z])/)[4];
        }
        paletteItems[m].setAttribute("title", title);
    }
    setPaletteCollections();
    var palette = $("#SymbolPalette").ejSymbolPalette("instance");
    palette.updateScrollerViewport();
    $("#artBoardWidth").ejNumericTextbox({ value: diagram.model.pageSettings.pageWidth });
    $("#artBoardHeight").ejNumericTextbox({ value: diagram.model.pageSettings.pageWidth });
    document.getElementById("maxi_Search").style.backgroundColor = "white";
    pageBackgroundColor = diagram.model.pageSettings.pageBackgroundColor;
    setDiagramSize();
});
$(window).resize(function () {
    var width = $(document).width() - $("#main-left").width();
    $("#main-right").css("width", width);
    var pixels = document.getElementById("sample-header").getBoundingClientRect().height;
    var screenHeight = document.body.clientHeight;
    document.getElementById("sample-main").style.height = (screenHeight - pixels) - 2 + "px";
    setDiagramSize();
    var palette = $("#SymbolPalette").ejSymbolPalette("instance");
    palette.updateScrollerViewport();
});
//$(function () {
//    $('#zoompercentage').ejDropDownList({
//        targetId: "zoompercentageList",
//        width: "75px",
//        height: "25px",
//        selectedItem: 3,
//        change: "evtpropscheckedevent",
//        popupPanelHeight: "250px",
//    });

//});

function onCheck(args) {;
    var paletteCollections = window.customShapes;
    var symbolPalette = $("#SymbolPalette").ejSymbolPalette("instance");
    var query = ej.Query().search(args.value, ["name"]);
    var data = ej.DataManager(paletteCollections).executeLocal(query)[0];

    if (data) {
        if (!symbolPalette.model.palettes.contains(data.palette)) {
            updatePalettePreview(data.palette);
            paletteCollection.push(data.palette);
        }
    }
    updatePaletteGruupInMinimized();
}
function updatePalettePreview(paletteToClone) {
    var palette = ej.datavisualization.Diagram.Palette({ "name": paletteToClone.name });
    palette.expanded = true;
    for (var i = 0; i < paletteToClone.items.length; i++) {
        var node = ej.datavisualization.Diagram.Util.clone(paletteToClone.items[i]);
        palette.push(node);

    }
    var tempPaletteCollection = [];
    previewPaletteCollection.push(palette);

    var parentElement = document.getElementById("palettePreview");
    var div = document.getElementById("palettePreviewDiv");
    if (!div) {
        div = document.createElement("div");
        parentElement.appendChild(div);
        div.id = "palettePreviewDiv";
        $(div).addClass("previewClass");
        $(div).ejSymbolPalette({ palettes: previewPaletteCollection, height: "300px", width: "465px", paletteItemWidth: 40, paletteItemHeight: 40, showPaletteItemText: true });
    }

}

function onUnCheck(args) {
    var symbolPalette = $("#SymbolPalette").ejSymbolPalette("instance");
    var query = ej.Query().search(args.value, ["name"]);
    var data = ej.DataManager(window.customShapes).executeLocal(query)[0];
    if (data) {
        var previewPalette = getPreviewPalette(data.palette.name);
        if (previewPaletteCollection.length > 0) {
            previewPaletteCollection.remove(previewPalette);
            paletteCollection.remove(data.palette);
        }
    }
    updatePaletteGruupInMinimized();
}
function getPreviewPalette(paletteName) {
    for (var i = 0; i < previewPaletteCollection.length; i++) {
        if (previewPaletteCollection[i].name == paletteName)
            return previewPaletteCollection[i];
    }
    return null;
}
///for hiding th div for opening the collapsed splitter
$("#expand_splitter")[0].style.display = "none";
$("#expand_splitter")[0].style.top = (document.defaultView.screen.availHeight / 2) - 75 + "px";



$("#expand_splitter").click(function () {
    document.getElementById("main-left").style.display = "block";
    document.getElementById("main-right").style.width = "80%";
    $("#expand_splitter")[0].style.display = "none";
});

//$("#insertLink").ejDialog({
//    width: 550,
//    close: "onDialogClose",
//    modal: true,
//    autoOpen: false
//});



//$("#basicDialog").ejDialog({
//    width: 451,
//    close: "onDialogClose",
//    autoOpen: false,
//    modal: true,
//});

//$("#basicDialogToLoad").ejDialog({
//    width: 550,
//    close: "onDialogClose",
//    autoOpen: false,
//    modal: true,
//});

//$("#FileOpenDialog").ejDialog(
//              {
//                  modal: true,
//                  resizable: false,
//                  width: 350,
//                  height: 400,
//                  close: "onDialogClose", autoOpen: false,
//              });
$("#confirmDialog").ejDialog({
    width: 451,
    close: "onDialogClose",
    showOnInit: false,
    enableModal: true,
});
$("#edit_splitter_hideslide").click(function () {
    isPMinized = true;

    $("#main-left").animate({ width: '40px' }, 300, function () {
        openMinimizedPalette();
        setDiagramSize();
    });


    document.getElementById("palette-div1").style.display = "none";
    document.getElementById("overview-div1").style.display = "none";

});
$("#edit_splitter_expandcollapse").click(function () {
    var symbolPalette = $("#SymbolPalette").ejSymbolPalette("instance");
    expand = !expand;
    if (expand) {
        symbolPalette.expandAll();
        $("#edit_splitter_expandcollapse")[0].style.backgroundImage = 'url("images/Colapse1.png")';
    } else {
        symbolPalette.collapseAll();
        $("#edit_splitter_expandcollapse")[0].style.backgroundImage = 'url("images/Expand1.png")';
    }
});


//});

function drppopupshow() {
    diagram = $("#DiagramContent").ejDiagram("instance");
}

$(document).click(function (e) {
    if ($(e.target).is('#showMinimizedPlatedItemsparent,#showMinimizedPlatedItemsparent *')) {
        if (showMinimizedPalette) {
            if (document.getElementById("showMinimizedPlatedItemsparent"))
                document.getElementById("showMinimizedPlatedItemsparent").style.display = "block";

        }
    }
    else {
        if (!showMinimizedPalette) {
            if (e.target.localName != "body" && document.getElementById("showMinimizedPlatedItemsparent")) {
                document.getElementById("showMinimizedPlatedItemsparent").style.display = "none";
                clearText()
            }
        }
    }
    showMinimizedPalette = false;
});

function openMinimizedPalette() {

    //document.getElementById("palette-div1").style.display = "none";

    document.getElementById("minimizedPalette").style.display = "block";
    document.getElementById("minimizedPalette").innerHTML = "";
    document.getElementById("Overview-div").style.display = "block";
    $(".chat-bubble-arrow-border-maxi").css("display", "none");
    $(".chat-bubble-arrow-maxi").css("display", "none");
    var palette = $("#SymbolPalette").ejSymbolPalette("instance");
    if (palette && palette.model.palettes.length) {
        var mPaletteDiv = document.getElementById("minimizedPalette");
        mPaletteDiv.style.height = "100%";
        mPaletteDiv.style.width = "40px";
        mPaletteDiv.style.backgroundColor = "transparent";
        mPaletteDiv.style.borderColor = "1px solid lightgray";
        mPaletteDiv.style.position = "relative";
        createMaxmizePalette(mPaletteDiv, "maximizesp");
        createSearchDiv(mPaletteDiv);
        createPletteDiv(palette, mPaletteDiv);
        createOverviewDiv(mPaletteDiv);
    }
}
function createMaxmizePalette(mPaletteDiv, id) {
    var nDiv; nDiv = document.createElement("div");
    nDiv.setAttribute("id", id);
    nDiv.setAttribute("title", "Maximize Palette");
    nDiv.setAttribute("class", id);
    nDiv.style.width = "100%";
    nDiv.style.height = "40px";
    nDiv.onclick = maximize;
    mPaletteDiv.appendChild(nDiv);
}
function createSearchDiv(mPaletteDiv, id) {
    var nDiv; nDiv = document.createElement("div");
    nDiv.setAttribute("class", "searchsp");
    nDiv.setAttribute("title", "Search from palette");
    nDiv.style.width = "100%";
    nDiv.style.height = "40px";
    //nDiv.style.backgroundColor = "pink";
    //nDiv.style.border = "1px solid white";
    nDiv.onclick = Search;
    mPaletteDiv.appendChild(nDiv);
}
function createOverviewDiv(mPaletteDiv)
{
    var nDiv; nDiv = document.createElement("div");
    nDiv.setAttribute("class", "overviewsp");
    nDiv.setAttribute("title", "Overview");
    nDiv.style.width = "100%";
    nDiv.style.height = "40px";
    nDiv.onclick = Overview;
    mPaletteDiv.appendChild(nDiv);
}
function createPletteDiv(palette, mPaletteDiv) {
    var nDiv;
    for (var i = 0; i < palette.model.palettes.length; i++) {
        if (palette.model.palettes[i].name != "BPMN Shapes") {
            nDiv = document.createElement("div");
            nDiv.style.width = "100%";
            nDiv.style.height = "40px";
            //nDiv.style.backgroundColor = "blue";
            //nDiv.style.border = "1px solid white";
            if (palette.model.palettes[i].name == "Basic Shapes")
                nDiv.onclick = Basic;
            if (palette.model.palettes[i].name == "Connectors")
                nDiv.onclick = Connectors;
            if (palette.model.palettes[i].name == "Flowchart Shapes")
                nDiv.onclick = Flow;
            if (palette.model.palettes[i].name == "Electrical Shape")
                nDiv.onclick = Electrical;
            if (palette.model.palettes[i].name == "Images")
                nDiv.onclick = Images;
            if (palette.model.palettes[i].name == "Intelligent Shapes")
                nDiv.onclick = interligent;

            nDiv.setAttribute("id", palette.model.palettes[i].name);
            nDiv.setAttribute("title", palette.model.palettes[i].name);
            if (palette.model.palettes[i].name != "BPMN Gateway")
                nDiv.setAttribute("class", (palette.model.palettes[i].name).split(" ")[0] + "sp");
            else
                nDiv.setAttribute("class", (palette.model.palettes[i].name).split(" ")[0] + "sp1");
            mPaletteDiv.appendChild(nDiv);
        }
    }
}
function moreShapeClick_mini() {
    $("#dialogCustom").ejDialog("open");
}
function createShowMinimizedPlatedItems() {
    //if (document.getElementById("showMinimizedPlatedItemsparent"))
    //    document.getElementById("showMinimizedPlatedItemsparent").parentNode.removeChild(document.getElementById("showMinimizedPlatedItemsparent"));
    //var div = document.createElement("div");
    var div = document.getElementById("showMinimizedPlatedItemsparent");
    div.setAttribute("id", "showMinimizedPlatedItemsparent");

    var divChild = document.createElement("div");
    divChild.setAttribute("id", "showMinimizedPlatedItems");
    div.appendChild(divChild);

    divChild = document.createElement("div");
    divChild.setAttribute("class", "chat-bubble-arrow-border-mini");
    div.appendChild(divChild);

    divChild = document.createElement("div");
    divChild.setAttribute("class", "chat-bubble-arrow-mini");
    div.appendChild(divChild);


    div.style.position = "absolute";
    div.style.height = "auto";
    div.style.width = "250px";
    div.style.backgroundColor = "white";
    div.style.border = "1px solid lightgray";
    div.style.borderRadius = "5px";
    div.style.left = "100px";
    div.style.top = "100px";
    div.style.padding = "10px";
    document.body.appendChild(div);
}
function createShowMaximizedPlatedItems() {

    var parent = document.getElementById("showMinimizedPlatedItemsparent");
    for (var i = 0; i < parent.childNodes.length; i++) {
        if (parent.childNodes[i].name == "arrow1" || parent.childNodes[i].name == "arrow2")
            parent.removeChild(childNodes[i]);
    }

    var div = parent;

    var divChild = document.createElement("div");
    divChild.setAttribute("id", "arrow1");
    divChild.setAttribute("class", "chat-bubble-arrow-border-maxi");
    div.appendChild(divChild);

    divChild = document.createElement("div");
    divChild.setAttribute("id", "arrow2");
    divChild.setAttribute("class", "chat-bubble-arrow-maxi");
    div.appendChild(divChild);


    div.style.position = "absolute";
    div.style.height = "auto";
    div.style.width = "250px";
    div.style.backgroundColor = "white";
    div.style.border = "1px solid lightgray";
    div.style.borderRadius = "5px";
    div.style.left = "100px";
    div.style.top = "100px";
    div.style.padding = "10px";
    document.body.appendChild(div);
}
function createShowMaximizedOverview() {

    var parent = document.getElementById("showMinimizedPlatedItemsparent");
    for (var i = 0; i < parent.childNodes.length; i++) {
        if (parent.childNodes[i].name == "arrow1" || parent.childNodes[i].name == "arrow2")
            parent.removeChild(childNodes[i]);
    }

    var div = parent;

    div.style.position = "absolute";
    div.style.height = "auto";
    div.style.width = "250px";
    div.style.backgroundColor = "white";
    div.style.border = "1px solid lightgray";
    div.style.left = "100px";
    div.style.top = "100px";
    document.body.appendChild(div);
}
function maximize() {

    isPMinized = false;
    document.getElementById("minimizedPalette").style.display = "none";
    document.getElementById("Overview-div").style.display = "none";
    if (document.getElementById("propertyEditor").style.display == "block") {
        document.getElementById("main-right").style.width = "63%";
    }
    else {
        document.getElementById("main-right").style.width = "80%";
    }



    $("#main-left").animate({ width: '270px' }, 300, function () {
        setDiagramSize();
    });


    document.getElementById("palette-div1").style.display = "block";
    document.getElementById("overview-div1").style.display = "block";

}
function Basic(evt) {
    createShowMinimizedPlatedItems();
    var bounds = evt.currentTarget.getBoundingClientRect();
    document.getElementById("showMinimizedPlatedItemsparent").style.left = bounds.right + 20 + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.top = bounds.top - 50 + "px";

    document.getElementById("showMinimizedPlatedItemsparent").style.position = "absolute";
    document.getElementById("showMinimizedPlatedItemsparent").style.display = "block";
    document.getElementById("maxi_Search").style.width = "250px";
    document.getElementById("maxi_Search").style.height = "auto";
    document.getElementById("maxi_Search").style.display = "block";
    document.getElementById("maxi_search_content").style.display = "block";
    document.getElementById("Overview-div").style.display = "none";
    $(".chat-bubble-arrow-border-mini").css("display", "block");
    $(".chat-bubble-arrow-mini").css("display", "block");
    $(".searchicon-parent-div").css("display", "none");

    var maxiPalette = $("#maxi_Search").ejSymbolPalette("instance");
    var maxipalettes = maxiPalette.model.palettes;

    for (var i = maxipalettes[0].items.length - 1; i >= 0; i--) {
        maxiPalette.removePaletteItem(maxipalettes[0].name, maxipalettes[0].items[i]);
    }

    for (var j = 0; j < window.basicShapes.length - 4; j++) {
        maxiPalette.addPaletteItem(maxipalettes[0].name, window.basicShapes[j]);
    }


    setToolTip();
    showMinimizedPalette = true;
    document.getElementById("basicShapes_Search").style.maxHeight = "330px";
    document.getElementById("showMinimizedPlatedItemsparent").style.display = "block";

}

function setToolTip() {
    var paletteItems = $("#maxi_search_content")[0].childNodes;
    for (m = 0; m < paletteItems.length; m++) {
        var title = "";
        var wWord = ((paletteItems[m].id).split("_")[0]);
        if (wWord) {
            if (wWord.split(/(?=[A-Z])/)[0])
                title += " " + wWord.split(/(?=[A-Z])/)[0];
            if (wWord.split(/(?=[A-Z])/)[1])
                title += " " + wWord.split(/(?=[A-Z])/)[1];
            if (wWord.split(/(?=[A-Z])/)[2])
                title += " " + wWord.split(/(?=[A-Z])/)[2];
            if (wWord.split(/(?=[A-Z])/)[3])
                title += " " + wWord.split(/(?=[A-Z])/)[3];
            if (wWord.split(/(?=[A-Z])/)[4])
                title += " " + wWord.split(/(?=[A-Z])/)[4];
        }
        paletteItems[m].setAttribute("title", title);
    }
}

function Images(evt) {
    createShowMinimizedPlatedItems();

    var bounds = evt.currentTarget.getBoundingClientRect();
    document.getElementById("showMinimizedPlatedItemsparent").style.left = bounds.right + 20 + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.top = bounds.top - 50 + "px";


    document.getElementById("maxi_Search").style.display = "none";
    document.getElementById("basicShapes_Search").style.display = "none";
    document.getElementById("flowShapes_search").style.display = "none";
    document.getElementById("electrical_Search").style.display = "none";
    document.getElementById("connectors_Search").style.display = "none";
    document.getElementById("intelligent_Search").style.display = "none";
    document.getElementById("Overview-div").style.display = "none";
    $(".searchicon-parent-div").css("display", "none");
    $(".chat-bubble-arrow-border-mini").css("display", "block");
    $(".chat-bubble-arrow-mini").css("display", "block");
    $(".chat-bubble-arrow-border-maxi").css("display", "none");
    $(".chat-bubble-arrow-maxi").css("display", "none");


    if (document.getElementById("showMinimizedPlatedItemsparent"))
        document.getElementById("showMinimizedPlatedItemsparent").style.display = "block";
    showMinimizedPalette = true;
    setToolTip();

}
function interligent(evt) {
    createShowMinimizedPlatedItems();

    var bounds = evt.currentTarget.getBoundingClientRect();
    document.getElementById("showMinimizedPlatedItemsparent").style.left = bounds.right + 20 + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.top = bounds.top - 50 + "px";

    document.getElementById("showMinimizedPlatedItemsparent").style.left = bounds.right + 20 + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.top = bounds.top - 50 + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.position = "absolute";
    document.getElementById("showMinimizedPlatedItemsparent").style.display = "block";
    document.getElementById("maxi_Search").style.width = "250px";
    document.getElementById("maxi_Search").style.height = "auto";
    document.getElementById("maxi_Search").style.display = "block";
    document.getElementById("maxi_search_content").style.display = "block";
    document.getElementById("Overview-div").style.display = "none";
    $(".chat-bubble-arrow-border-mini").css("display", "block");
    $(".chat-bubble-arrow-mini").css("display", "block");
    $(".searchicon-parent-div").css("display", "none");
    var maxiPalette = $("#maxi_Search").ejSymbolPalette("instance");
    var maxipalettes = maxiPalette.model.palettes;

    for (var i = maxipalettes[0].items.length - 1; i >= 0; i--) {
        maxiPalette.removePaletteItem(maxipalettes[0].name, maxipalettes[0].items[i]);
    }

    for (var j = 0; j < window.interligent.length - 4; j++) {
        maxiPalette.addPaletteItem(maxipalettes[0].name, window.interligent[j]);
    }
    showMinimizedPalette = true;
    document.getElementById("basicShapes_Search").style.maxHeight = "330px";
    document.getElementById("showMinimizedPlatedItemsparent").style.display = "block";
    setToolTip();
}
function Connectors(evt) {
    createShowMinimizedPlatedItems();

    var bounds = evt.currentTarget.getBoundingClientRect();
    document.getElementById("showMinimizedPlatedItemsparent").style.left = bounds.right + 20 + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.top = bounds.top - 50 + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.left = bounds.right + 20 + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.top = bounds.top - 50 + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.position = "absolute";
    document.getElementById("showMinimizedPlatedItemsparent").style.display = "block";
    document.getElementById("maxi_Search").style.width = "250px";
    document.getElementById("maxi_Search").style.height = "auto";
    document.getElementById("maxi_Search").style.display = "block";
    document.getElementById("maxi_search_content").style.display = "block";
    document.getElementById("Overview-div").style.display = "none";
    $(".chat-bubble-arrow-border-mini").css("display", "block");
    $(".chat-bubble-arrow-mini").css("display", "block");
    $(".searchicon-parent-div").css("display", "none");
    var maxiPalette = $("#maxi_Search").ejSymbolPalette("instance");
    var maxipalettes = maxiPalette.model.palettes;

    for (var i = maxipalettes[0].items.length - 1; i >= 0; i--) {
        maxiPalette.removePaletteItem(maxipalettes[0].name, maxipalettes[0].items[i]);
    }

    for (var j = 0; j < window.connectors.length - 1; j++) {
        maxiPalette.addPaletteItem(maxipalettes[0].name, window.connectors[j]);
    }
    showMinimizedPalette = true;
    document.getElementById("basicShapes_Search").style.maxHeight = "330px";
    document.getElementById("showMinimizedPlatedItemsparent").style.display = "block";
    setToolTip();
}
function Flow(evt) {

    createShowMinimizedPlatedItems();

    var bounds = evt.currentTarget.getBoundingClientRect();
    document.getElementById("showMinimizedPlatedItemsparent").style.left = bounds.right + 20 + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.top = bounds.top - 50 + "px";

    document.getElementById("showMinimizedPlatedItemsparent").style.left = bounds.right + 20 + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.top = bounds.top - 50 + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.position = "absolute";
    document.getElementById("showMinimizedPlatedItemsparent").style.display = "block";
    document.getElementById("maxi_Search").style.width = "250px";
    document.getElementById("maxi_Search").style.height = "auto";
    document.getElementById("maxi_Search").style.display = "block";
    document.getElementById("maxi_search_content").style.display = "block";
    document.getElementById("Overview-div").style.display = "none";
    $(".searchicon-parent-div").css("display", "none");
    $(".chat-bubble-arrow-border-mini").css("display", "block");
    $(".chat-bubble-arrow-mini").css("display", "block");

    var maxiPalette = $("#maxi_Search").ejSymbolPalette("instance");
    var maxipalettes = maxiPalette.model.palettes;

    for (var i = maxipalettes[0].items.length - 1; i >= 0; i--) {
        maxiPalette.removePaletteItem(maxipalettes[0].name, maxipalettes[0].items[i]);
    }

    for (var j = 0; j < window.flowShapes.length - 4; j++) {
        maxiPalette.addPaletteItem(maxipalettes[0].name, window.flowShapes[j]);
    }
    showMinimizedPalette = true;
    document.getElementById("basicShapes_Search").style.maxHeight = "330px";
    document.getElementById("showMinimizedPlatedItemsparent").style.display = "block";
    setToolTip();
}
function Electrical(evt) {
    createShowMinimizedPlatedItems();

    var bounds = evt.currentTarget.getBoundingClientRect();
    document.getElementById("showMinimizedPlatedItemsparent").style.left = bounds.right + 20 + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.top = bounds.top - 50 + "px";


    document.getElementById("showMinimizedPlatedItemsparent").style.left = bounds.right + 20 + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.top = bounds.top - 50 + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.position = "absolute";
    document.getElementById("showMinimizedPlatedItemsparent").style.display = "block";
    document.getElementById("maxi_Search").style.width = "250px";
    document.getElementById("maxi_Search").style.height = "auto";
    document.getElementById("maxi_Search").style.display = "block";
    document.getElementById("maxi_search_content").style.display = "block";
    document.getElementById("Overview-div").style.display = "none";
    $(".searchicon-parent-div").css("display", "none");
    $(".chat-bubble-arrow-border-mini").css("display", "block");
    $(".chat-bubble-arrow-mini").css("display", "block");

    var maxiPalette = $("#maxi_Search").ejSymbolPalette("instance");
    var maxipalettes = maxiPalette.model.palettes;

    for (var i = maxipalettes[0].items.length - 1; i >= 0; i--) {
        maxiPalette.removePaletteItem(maxipalettes[0].name, maxipalettes[0].items[i]);
    }

    for (var j = 0; j < window.electricalShapes.length - 4; j++) {
        maxiPalette.addPaletteItem(maxipalettes[0].name, window.electricalShapes[j]);
    }
    showMinimizedPalette = true;
    document.getElementById("basicShapes_Search").style.maxHeight = "330px";
    document.getElementById("showMinimizedPlatedItemsparent").style.display = "block";
    setToolTip();
}
function clearText() {
    if (document.getElementById("textbox_maxi"))
        document.getElementById("textbox_maxi").value = "";
    if (document.getElementById("miniSearchBox"))
        document.getElementById("miniSearchBox").value = "";
    if (document.getElementById("searchbox_icon-mini"))
        document.getElementById("searchbox_icon-mini").style.backgroundImage = 'url("../../Content/diagram/images/Search-Find.png")';
    if (document.getElementById("searchbox_icon-maxi"))
        document.getElementById("searchbox_icon-maxi").style.backgroundImage = 'url("../../Content/diagram/images/Search-Find.png")';
    onSearchBoxTextChange();
}
function Search(evt) {

    document.getElementById("no_match_found").style.display = "none";

    createShowMinimizedPlatedItems();
    var pdiv = document.createElement("div");
    pdiv.setAttribute("class", "searchicon-parent-div");

    var cdiv = document.createElement("div");
    cdiv.setAttribute("id", "searchbox_icon-mini");
    cdiv.setAttribute("class", "searchbox_icon-mini");
    cdiv.onclick = clearText;
    var textBox = document.createElement("input");
    pdiv.appendChild(textBox);
    pdiv.appendChild(cdiv);

    textBox.style.height = "30px";
    textBox.style.width = "80%";
    textBox.style.outline = "none";
    textBox.style.marginLeft = "4px";
    textBox.setAttribute("type", "text");
    textBox.setAttribute("id", "miniSearchBox");
    textBox.onkeyup = onSearchBoxTextChange;
    textBox.style.border = "none";

    if (document.getElementById("showMinimizedPlatedItemsparent").firstChild)
        document.getElementById("showMinimizedPlatedItemsparent").insertBefore(pdiv, document.getElementById("showMinimizedPlatedItemsparent").firstChild);
    else
        document.getElementById("showMinimizedPlatedItemsparent").appendChild(pdiv);


    var bounds = evt.currentTarget.getBoundingClientRect();
    document.getElementById("showMinimizedPlatedItemsparent").style.left = bounds.right + 20 + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.top = bounds.top - 30 + "px";


    document.getElementById("maxi_Search").style.display = "block";
    document.getElementById("basicShapes_Search").style.display = "none";
    document.getElementById("flowShapes_search").style.display = "none";
    document.getElementById("electrical_Search").style.display = "none";
    document.getElementById("connectors_Search").style.display = "none";
    document.getElementById("intelligent_Search").style.display = "none";
    document.getElementById("Overview-div").style.display = "none";
    $(".chat-bubble-arrow-border-mini").css("display", "block");
    $(".chat-bubble-arrow-mini").css("display", "block");
    $(".chat-bubble-arrow-border-maxi").css("display", "none");
    $(".chat-bubble-arrow-maxi").css("display", "none");
    if ($(".searchicon-parent-div").length > 1) {
        for (var i = 1; i < $(".searchicon-parent-div").length; i++) {
            $(".searchicon-parent-div")[i].parentNode.removeChild($(".searchicon-parent-div")[i]);
        }
    }
    $(".searchicon-parent-div").css("display", "block");


    if (document.getElementById("showMinimizedPlatedItemsparent"))
        document.getElementById("showMinimizedPlatedItemsparent").style.display = "block";
    showMinimizedPalette = true;
    if ($("#showMinimizedPlatedItems")[0].childNodes.length > 0) {
        var count = $("#showMinimizedPlatedItems")[0].childNodes.length;
        for (var i = 0; i < count; i++)
            if ((i % 2) == 0)
                $("#showMinimizedPlatedItems")[0].childNodes[i].style.display = "none";
    }
    if (document.getElementById("maxi_Search"))
        document.getElementById("maxi_Search").style.maxHeight = "400px";
    document.getElementsByClassName("chat-bubble-arrow-mini")[0].style.top = "28px;";
    document.getElementsByClassName("chat-bubble-arrow-border-mini")[0].style.top = "28px;";

    document.getElementById("showMinimizedPlatedItems").style.display = "none";

    document.getElementById("maxi_Search").style.width = "250px";
    document.getElementById("maxi_Search").style.height = "auto";
    document.getElementById("maxi_Search").style.display = "none";
    document.getElementById("miniSearchBox").value = "";
    $(".searchicon-parent-div").css("display", "block");
}
function Overview(evt)
{
    createShowMaximizedOverview();

    var bounds = evt.currentTarget.getBoundingClientRect();
    document.getElementById("showMinimizedPlatedItemsparent").style.left = bounds.right + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.top = bounds.top - 175 + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.position = "absolute";
    document.getElementById("showMinimizedPlatedItemsparent").style.display = "block";
    document.getElementById("maxi_Search").style.display = "none";
    document.getElementById("maxi_search_content").style.display = "block";
    document.getElementById("Overview-div").style.display = "block";

    $(".searchicon-parent-div").css("display", "none");
    $("#minOverview").ejOverview({ sourceID: "DiagramContent", height: 172, width: 232 });
    showMinimizedPalette = true;
}
function maxiTextBoxClick() {
    createShowMaximizedPlatedItems();
    clearText();

    document.getElementById("showMinimizedPlatedItemsparent").style.left = 5 + "px";
    document.getElementById("showMinimizedPlatedItemsparent").style.top = 137 + "px";

    $(".searchicon-parent-div").css("display", "block");
}
function onSearchBoxTextChange() {
    var item = null;
    if (document.getElementById("miniSearchBox"))
        var key = document.getElementById("miniSearchBox").value;
    if (document.getElementById("subControl_Div"))
        document.getElementById("subControl_Div").style.display = "none";
    $("#showMinimizedPlatedItems").find(".e-content").removeClass("e-content");
    if (key && key == "") {
        if (document.getElementById("showMinimizedPlatedItems"))
            document.getElementById("showMinimizedPlatedItems").style.display = "none";
    } else {
        if (document.getElementById("showMinimizedPlatedItems"))
            document.getElementById("showMinimizedPlatedItems").style.display = "block";
    }
    if (key && key.length > 0) {
        if (document.getElementById("maxi_Search"))
            document.getElementById("maxi_Search").style.display = "block";
        document.getElementById("maxi_search_content").style.display = "block";
        document.getElementById("maxi_Search").style.width = "250px";
        document.getElementById("maxi_Search").style.height = "auto";
        if (document.getElementById("showMinimizedPlatedItemsparent"))
            document.getElementById("showMinimizedPlatedItemsparent").style.display = "block";
        if (document.getElementById("showMinimizedPlatedItems_canvas"))
            document.getElementById("showMinimizedPlatedItems_canvas").style.display = "block";


        var maxiPalette = $("#maxi_Search").ejSymbolPalette("instance");
        var maxipalettes = maxiPalette.model.palettes;
        var palette = $("#SymbolPalette").ejSymbolPalette("instance");
        var palettes = palette.model.palettes;
        item = null;

        for (var i = maxipalettes[0].items.length - 1; i >= 0; i--) {
            maxiPalette.removePaletteItem(maxipalettes[0].name, maxipalettes[0].items[i]);
        }

        for (i = 0; i < palettes.length; i++) {
            if (palettes[i].name != "BPMN Shapes") {
                for (var j = 0; j < palettes[i].items.length; j++) {
                    item = palettes[i].items[j];

                    var itemName = (item.name).split(/(?=[A-Z])/)
                    key = key.toLocaleLowerCase();
                    item = $.extend(true, {}, item);

                    if ((itemName[0]).toLocaleLowerCase().indexOf(key) == 0) {
                        maxiPalette.addPaletteItem(maxiPalette.model.palettes[0].name, item);

                    } else if (itemName[1] && ((itemName[1]).toLocaleLowerCase().indexOf(key) == 0)) {
                        maxiPalette.addPaletteItem(maxiPalette.model.palettes[0].name, item);

                    } else if (itemName[2] && ((itemName[2]).toLocaleLowerCase().indexOf(key) == 0)) {
                        maxiPalette.addPaletteItem(maxiPalette.model.palettes[0].name, item);
                    } else if (itemName[3] && ((itemName[3]).toLocaleLowerCase().indexOf(key) == 0)) {
                        maxiPalette.addPaletteItem(maxiPalette.model.palettes[0].name, item);
                    }
                }
            }

        }



    } else {
        if (document.getElementById("maxi_Search"))
            document.getElementById("maxi_Search").style.display = "none";
    }
    if (key && key == "") {
        if (document.getElementById("searchbox_icon-mini"))
            document.getElementById("searchbox_icon-mini").style.backgroundImage = 'url("../../Content/diagram/images/Search-Find.png")';
    }
    else {
        if (document.getElementById("searchbox_icon-mini"))
            document.getElementById("searchbox_icon-mini").style.backgroundImage = 'url("../../Content/diagram/images/Close.png")';
    }
    setToolTip();
}
function evtpropscheckedevent(args) {
    var diagram = $("#DiagramContent").ejDiagram("instance");
    var currentZoom = diagram._getCurrentZoom();
    if (args.text) {
        switch (args.text) {
            case "400%":
                zoom.zoomFactor = (4 / currentZoom) - 1;
                diagram.zoomTo(zoom);
                setZoomSlider();
                break;
            case "200%":
                zoom.zoomFactor = (2 / currentZoom) - 1;
                diagram.zoomTo(zoom);
                setZoomSlider();
                break;
            case "150%":
                zoom.zoomFactor = (1.5 / currentZoom) - 1;
                diagram.zoomTo(zoom);
                setZoomSlider();
                break;
            case "100%":
                zoom.zoomFactor = (1 / currentZoom) - 1;
                diagram.zoomTo(zoom);
                setZoomSlider();
                break;
            case "75%":
                zoom.zoomFactor = (0.75 / currentZoom) - 1;
                diagram.zoomTo(zoom);
                setZoomSlider();
                break;
            case "50%":
                zoom.zoomFactor = (0.5 / currentZoom) - 1;
                diagram.zoomTo(zoom);
                setZoomSlider();
                break;
            case "25%":
                zoom.zoomFactor = (0.25 / currentZoom) - 1;
                diagram.zoomTo(zoom);
                setZoomSlider();
                break;
        }
    }

}
function setZoomSlider() {
    $("#overviewSlider").ejSlider('option', 'value', String(Math.round(diagram._getCurrentZoom() * 100)));
    $("#minSlider").ejSlider('option', 'value', String(Math.round(diagram._getCurrentZoom() * 100)));
    var sliderValue = document.getElementsByClassName("sliderValue");
    for (var i = 0; i < sliderValue.length; i++)
        sliderValue[i].textContent = String(Math.round(diagram._getCurrentZoom() * 100)) + "%";
}
function onSearchBoxTextChange_maxi() {
    document.getElementById("maxi_Search").style.minHeight = "40px";
    if (document.getElementById("textbox_maxi"))
        var key = document.getElementById("textbox_maxi").value;
    if (key.length > 0) {

        var maxiPalette = $("#maxi_Search").ejSymbolPalette("instance");
        var maxipalettes = maxiPalette.model.palettes;
        //for (i = maxipalettes[0].items.length - 1; i >= 0; i--) {
        //    ej.datavisualization.Diagram.Util.removeItem(maxipalettes[0].items, maxipalettes[0].items[i]);
        //}
        document.getElementById("maxi_search_content").style.display = "block";
        document.getElementById("maxi_Search").style.width = "250px";
        document.getElementById("maxi_Search").style.height = "auto";
        if (document.getElementById("showMinimizedPlatedItemsparent"))
            document.getElementById("showMinimizedPlatedItemsparent").style.display = "block";
        if (document.getElementById("showMinimizedPlatedItems_canvas"))
            document.getElementById("showMinimizedPlatedItems_canvas").style.display = "block";

        document.getElementById("maxi_Search").style.display = "block";
        document.getElementById("basicShapes_Search").style.display = "none";
        document.getElementById("flowShapes_search").style.display = "none";
        document.getElementById("electrical_Search").style.display = "none";
        document.getElementById("connectors_Search").style.display = "none";
        document.getElementById("intelligent_Search").style.display = "none";
        $(".searchicon-parent-div").css("display", "none");
        $(".chat-bubble-arrow-border-mini").css("display", "none");
        $(".chat-bubble-arrow-mini").css("display", "none");
        $(".chat-bubble-arrow-border-maxi").css("display", "block");
        $(".chat-bubble-arrow-maxi").css("display", "block");


        var palette = $("#SymbolPalette").ejSymbolPalette("instance");
        var palettes = palette.model.palettes;
        var item = null;

        if (maxipalettes[0].items) {
            for (var i = maxipalettes[0].items.length - 1; i >= 0; i--) {
                maxiPalette.removePaletteItem(maxipalettes[0].name, maxipalettes[0].items[i]);
            }
        }

        for (var i = 0; i < palettes.length; i++) {
            if (palettes[i].name != "BPMN Shapes") {
                for (var j = 0; j < palettes[i].items.length; j++) {
                    item = palettes[i].items[j];

                    var itemName = (item.name).split(/(?=[A-Z])/);
                    key = key.toLocaleLowerCase();
                    item = $.extend(true, {}, item);

                    if ((itemName[0]).toLocaleLowerCase().indexOf(key) == 0) {
                        maxiPalette.addPaletteItem(maxiPalette.model.palettes[0].name, item);

                    }
                    else if (itemName[1] && ((itemName[1]).toLocaleLowerCase().indexOf(key) == 0)) {
                        maxiPalette.addPaletteItem(maxiPalette.model.palettes[0].name, item);

                    }
                    else if (itemName[2] && ((itemName[2]).toLocaleLowerCase().indexOf(key) == 0)) {
                        maxiPalette.addPaletteItem(maxiPalette.model.palettes[0].name, item);
                    }
                    else if (itemName[3] && ((itemName[3]).toLocaleLowerCase().indexOf(key) == 0)) {
                        maxiPalette.addPaletteItem(maxiPalette.model.palettes[0].name, item);
                    }
                }
            }

        }

        if (maxipalettes[0].items.length <= 0) {
            document.getElementById("no_match_found").style.display = "block";
            document.getElementById("maxi_Search").style.display = "none";
        }
        else {
            document.getElementById("no_match_found").style.display = "none";
            document.getElementById("maxi_Search").style.display = "block";
        }


        if (document.getElementById("subControl_Div"))
            document.getElementById("subControl_Div").style.display = "none";
        $("#showMinimizedPlatedItems").find(".e-content").removeClass("e-content");
        if (key == "") {
            if (document.getElementById("showMinimizedPlatedItemsparent"))
                document.getElementById("showMinimizedPlatedItemsparent").style.display = "none";
        } else {
            if (document.getElementById("showMinimizedPlatedItemsparent"))
                document.getElementById("showMinimizedPlatedItemsparent").style.display = "block";
        }
        if (key == "") {
            document.getElementById("searchbox_icon-maxi").style.backgroundImage = 'url("../../Content/diagram/images/Search-Find.png")';
        } else {

            document.getElementById("searchbox_icon-maxi").style.backgroundImage = 'url("../../Content/diagram/images/Close.png")';
        }
    }

    else {
        if (document.getElementById("showMinimizedPlatedItemsparent"))
            document.getElementById("showMinimizedPlatedItemsparent").style.display = "none";
    }
    setToolTip();
}
function updatePaletteGruupInMinimized(clonePalette) {
    if (document.getElementById("minimizedPalette") && document.getElementById("minimizedPalette").childNodes.length > 0) {
        openMinimizedPalette();
    }
}
function setDiagramSize(showpropeditor) {
    var diagram = $("#DiagramContent").ejDiagram("instance");
    var width = $(window).width() - $("#main-left").width();
    var pwidth = $("#propertyEditor").width();
    if (!showpropeditor)
        pwidth = 0;
    $("#main-right").css("width", width - pwidth);
    $("#main-right").css("height", "100%");
    $("#DiagramContent")[0].style.height = "100%";
    $("#DiagramContent")[0].style.width = "100%";
    diagram.updateViewPort();
}

function setPaletteCollections() {
    window.basicShapes = [];
    window.flowShapes = [];
    window.electricalShapes = [];
    window.connectors = [];
    window.iterligentShapes = [];

    var palette = $("#SymbolPalette").ejSymbolPalette("instance");
    for (var i = 0; i < palette.model.palettes.length; i++) {
        var symPalette = palette.model.palettes[i];
        var j;
        switch (symPalette.name) {
            case "Basic Shapes":
                for (j = 0; j < symPalette.items.length; j++) {
                    window.basicShapes.push($.extend(true, {}, symPalette.items[j]));
                }
                break;
            case "Flowchart Shapes":
                for (j = 0; j < symPalette.items.length; j++) {
                    window.flowShapes.push($.extend(true, {}, symPalette.items[j]));
                }
                break;
            case "Electrical Shape":
                for (j = 0; j < symPalette.items.length; j++) {
                    this.electricalShapes.push($.extend(true, {}, symPalette.items[j]));
                }
                break;
            case "Connectors":
                for (j = 0; j < symPalette.items.length; j++) {
                    window.connectors.push($.extend(true, {}, symPalette.items[j]));
                }
                break;
            case "Intelligent Shapes":
                for (j = 0; j < symPalette.items.length; j++) {
                    window.iterligentShapes.push($.extend(true, {}, symPalette.items[j]));
                }
                break;
        }
    }

    var collection1 = [];
    collection1.name = "maxi";
    var max = [];
    max.name = "maxi_search";
    max.items = [];
    collection1.push(max);
    $("#maxi_Search").ejSymbolPalette({ diagramId: "DiagramContent",palettes: collection1, height: "100%", width: "250px", paletteItemWidth: 45, paletteItemHeight: 45, showPaletteItemText: false });


}



function createUserHandles(userHandles) {
    var CloneTool = (function (base) {
        ej.datavisualization.Diagram.extend(CloneTool, base);
        function CloneTool(name) {
            base.call(this, name);
            this.singleAction = true;
            this.clonedNodes = [];
            this.diffx = 0;
            this.diffy = 0;
            this.cursor = "pointer";
            this.check = false;
        }
        CloneTool.prototype.mousedown = function (evt) {
            base.prototype.mousedown.call(this, evt);
            this.selectedObject = this.diagram.selectionList[0];
            this.check = true;
        };
        CloneTool.prototype.mousemove = function (evt) {
            base.prototype.mousemove.call(this, evt);
            if (this.selectedObject) {
                if (!this.inAction) {
                    this.check = false;
                    this.inAction = true;
                    this.diagram.copy();
                    this.diagram.paste();
                    this.clonedNodes = [];
                    this.clonedNodes.push(this.diagram.nameTable[this.diagram.selectionList[0].name]);
                }
                else {
                    if (ej.datavisualization.Diagram.Util.canMove(this.clonedNodes[0]))
                        this._updateClonedNode(true);
                }
            }
            this.previousPoint = this.currentPoint;
        };
        CloneTool.prototype.mouseup = function (evt) {
            if (this.check) {
                this.diagram.copy();
                this.diagram.paste();
                this.clonedNodes = [];
                this.clonedNodes.push(this.diagram.nameTable[this.diagram.selectionList[0].name]);

            } else {
                if (this.inAction) {
                    this.inAction = false;
                    this._updateClonedNode(false);

                }
            }
            this.check = false;
            this.diagram.selectionList[0] = this.clonedNodes[0];
            this.clonedNodes = [];
            base.prototype.mouseup.call(this, evt);
        };
        CloneTool.prototype._updateClonedNode = function (isDragging) {
            if (this.clonedNodes[0].isGroup && !this.clonedNodes[0].isPseudoGroup) {
                this.clonedNodes[0].offsetX += (this.currentPoint.x - this.previousPoint.x);
                this.clonedNodes[0].offsetY += (this.currentPoint.y - this.previousPoint.y);
                diagram._translate(this.clonedNodes[0], this.currentPoint.x - this.previousPoint.x, this.currentPoint.y - this.previousPoint.y, this.diagram.nameTable);
                ej.datavisualization.Diagram.DiagramContext.update(this.clonedNodes[0], this.diagram);

            }
            else if (this.clonedNodes[0].isPseudoGroup) {
                diagram._translate(this.clonedNodes[0], this.currentPoint.x - this.previousPoint.x, this.currentPoint.y - this.previousPoint.y, this.diagram.nameTable);
                for (var i = 0, len = this.clonedNodes[0].children.length; i < len; i++) {
                    var child = this.diagram.nameTable[this.clonedNodes[0].children[i]];
                    ej.datavisualization.Diagram.DiagramContext.update(child, this.diagram);
                }
            }
            else {
                for (var i = 0; i < this.clonedNodes.length; i++) {
                    this.clonedNodes[i].offsetX += (this.currentPoint.x - this.previousPoint.x);
                    this.clonedNodes[i].offsetY += (this.currentPoint.y - this.previousPoint.y);
                    if (this.clonedNodes[i].isGroup) {
                        this._updateXY(this.clonedNodes[i], this.previousPoint, this.currentPoint);
                        ej.datavisualization.Diagram.DiagramContext.update(this.clonedNodes[i], this.diagram);

                    } else {
                        //this.clonedNodes[i].updatebounds();
                        ej.datavisualization.Diagram.DiagramContext.update(this.clonedNodes[i], this.diagram);
                    }
                }
            }
            this.diagram.updateSelection(isDragging);
        };
        CloneTool.prototype._updateXY = function (shape, startPoint, endPoint) {
            var offsetwithoutsnap = ej.datavisualization.Diagram.Point(endPoint.x - startPoint.x, endPoint.y - startPoint.y);
            var towardsLeft = endPoint.x < startPoint.x;
            var towardsTop = endPoint.y < startPoint.y;
            var difx = this.diffx + (endPoint.x - startPoint.x) / this.diagram._getCurrentZoom();
            var dify = this.diffy + (endPoint.y - startPoint.y) / this.diagram._getCurrentZoom();
            var offset;
            offset = this.diagram._snapping._snapPosition(this.selectedObject, towardsLeft, towardsTop, ej.datavisualization.Diagram.Point(difx, dify), endPoint, startPoint);

            this.diffx = difx - offset.x;
            this.diffy = dify - offset.y;
            ej.datavisualization.Diagram.Util._translate(shape, (endPoint.x - startPoint.x), (endPoint.y - startPoint.y));

        };
        return CloneTool;
    })(ej.datavisualization.Diagram.ToolBase);

    var cloneHandle = ej.datavisualization.Diagram.UserHandle();
    cloneHandle.name = "Clone";
    cloneHandle.position = ej.datavisualization.Diagram.UserHandlePositions.BottomLeft;//"bottomLeft";
    cloneHandle.visible = true;
    cloneHandle.tool = new CloneTool(cloneHandle.name);
    cloneHandle.enableMultiSelection = true;
    cloneHandle.size = 30;
    cloneHandle.backgroundColor = "#4D4D4D";
    cloneHandle.pathData = "M4.6350084,4.8909971 L4.6350084,9.3649971 9.5480137,9.3649971 9.5480137,4.8909971 z M3.0000062,2.8189973 L11.184016,2.8189973 11.184016,10.999997 3.0000062,10.999997 z M0,0 L7.3649998,0 7.3649998,1.4020001 1.4029988,1.4020001 1.4029988,8.0660002 0,8.0660002 0,1.4020001 0,0.70300276 z";
    userHandles.push(cloneHandle);

    var AnchorTool = (function (base) {
        ej.datavisualization.Diagram.extend(AnchorTool, base);
        function AnchorTool(name) {
            base.call(this, name);
            this.singleAction = true;
            this.cursor = "pointer";
        }
        AnchorTool.prototype.mouseup = function (evt) {
            $("#tabitems").ejTab("option", "selectedItemIndex", 2);
            setDiagramSize(true);
            document.getElementById("propertyEditor").style.display = "block";
            base.prototype.mouseup.call(this, evt);
        }
        return AnchorTool;
    })(ej.datavisualization.Diagram.ToolBase);

    var anchorTool = ej.datavisualization.Diagram.UserHandle();
    anchorTool.name = "Label";
    //anchorTool.position = "topLeft";
    anchorTool.position = ej.datavisualization.Diagram.UserHandlePositions.TopLeft;
    anchorTool.visible = true;

    anchorTool.tool = new AnchorTool(anchorTool.name);
    anchorTool.size = 30;
    anchorTool.backgroundColor = "#4D4D4D";
    anchorTool.enableMultiSelection = true;
    anchorTool.pathData = "M64.3965,24.4844L66.4545,18.5024C66.5335,18.2714,66.6035,17.9574,66.6645,17.5614L66.7285,17.8294C66.7985,18.2604,66.8425,18.3074,66.9045,18.5024L68.9865,24.4844z M68.1495,15.3334L65.3475,15.3334L59.7315,30.3334L62.4505,30.3334L63.7485,26.5144L69.6475,26.5144L70.9955,30.3334L73.7255,30.3334z";
    userHandles.push(anchorTool);


    var LinkTool = (function (base) {
        var node = null;
        var targetNode = null;
        ej.datavisualization.Diagram.extend(LinkTool, base);
        function LinkTool(name) {
            base.call(this, name);
            this.singleAction = true;
            this.cursor = "pointer";
            return this;
        }
        LinkTool.prototype.mousedown = function (evt) {
            node = this.diagram.selectionList[0];
            this._currentPossibleConnection = node;
            this._possibleConnectionPort = node.ports[0];
            base.prototype.mousedown.call(this, evt);
            this._showAllPorts();
            this.diagram.addSelection(node);
            this._sourcePossibleConnection = node;
            targetNode = null;
        };

        LinkTool.prototype.mouseup = function (evt) {
            if (evt.target.id == "Line_shape") {
                this.inAction = false;
                this.diagram._clearSelection();
                if (this.helper)
                    this.diagram._remove(this.helper);
                this.helper = null;
                this.svgHelper = null;
                base.prototype.mouseup.call(this, evt);
                this.diagram.deactivateTool();
                this.diagram.activateTool("orthogonalLine", true);
            }
            else {
                if (this._sourcePossibleConnection && this._sourcePossibleConnection.ports.length > 0)
                    if (!this._targetPossibleConnection) {
                        if (!this._targetPort) {
                            var dNode = this._createDynamicNode(node);
                            this.diagram.add(dNode);
                            this._targetPossibleConnection = dNode;
                            this._targetPort = dNode.ports[0];
                        }
                    }
                targetNode = this._targetPossibleConnection.name;
                this.diagram._updateEdges(this);
                this._showAllPorts(true);
                base.prototype.mouseup.call(this, evt);
            }

            if (targetNode) {
                this.diagram._clearSelection();
                //    this.diagram.selectionList.add(this._targetPossibleConnection)
                this.diagram.addSelection(targetNode)
            }

        };

        LinkTool.prototype._createDynamicNode = function (node) {
            var node = $.extend(true, {}, node);
            node.outEdges = [];
            node.offsetX = this.currentPoint.x;
            node.offsetY = this.currentPoint.y;
            node.name = node.name + ej.datavisualization.Diagram.Util.randomId();
            return node;
        };
        return LinkTool;
    })(ej.datavisualization.Diagram.OrthogonalLineTool);

    var linkHandle = ej.datavisualization.Diagram.UserHandle();
    linkHandle.name = "Line";
    //linkHandle.position = "middleRight";

    linkHandle.position = ej.datavisualization.Diagram.UserHandlePositions.MiddleRight;
    linkHandle.visible = true;

    linkHandle.tool = new LinkTool(linkHandle.name);
    linkHandle.size = 30;
    linkHandle.backgroundColor = "#4D4D4D";
    linkHandle.pathData = "M196.2104,93.6494L196.2104,90.2544L189.1674,90.2544L189.1674,87.6694L196.2104,87.6694L196.2104,84.7344L200.6674,89.1914z";
    userHandles.push(linkHandle);

    var SettingsTool = (function (base) {
        ej.datavisualization.Diagram.extend(SettingsTool, base);
        function SettingsTool(name) {
            base.call(this, name);
            this.singleAction = true;
            this.cursor = "pointer";
        }
        SettingsTool.prototype.mouseup = function (evt) {
            if (diagram.selectionList[0].shape || diagram.selectionList[0].isPseudoGroup || diagram.selectionList[0].isGroup) {
                if (diagram.selectionList[0].isPseudoGroup) {
                    for (var i = 0; i < diagram.selectionList[0].children.length; i++) {
                        var child = diagram.nameTable[diagram.selectionList[0].children[i]];
                        if (child.shape) {
                            $("#tabitems").ejTab("option", "selectedItemIndex", 1);
                            break;
                        }
                        else
                            $("#tabitems").ejTab("option", "selectedItemIndex", 3);
                    }
                }
                else
                    $("#tabitems").ejTab("option", "selectedItemIndex", 1);
            }
            else if (diagram.selectionList[0].segments) {
                $("#tabitems").ejTab("option", "selectedItemIndex", 3);
            }
            setDiagramSize(true);
            document.getElementById("propertyEditor").style.display = "block";
            base.prototype.mouseup.call(this, evt);
        }
        return SettingsTool;
    })(ej.datavisualization.Diagram.ToolBase);

    var settingHandle = ej.datavisualization.Diagram.UserHandle();
    settingHandle.name = "Settings";
    //settingHandle.position = "bottomRight";

    settingHandle.position = ej.datavisualization.Diagram.UserHandlePositions.BottomRight;
    settingHandle.visible = true;

    settingHandle.tool = new SettingsTool(settingHandle.name);
    settingHandle.size = 30;
    settingHandle.backgroundColor = "#4D4D4D";
    settingHandle.enableMultiSelection = true;
    settingHandle.pathData = "M22.0542,27.332C20.4002,27.332,19.0562,25.987,19.0562,24.333C19.0562,22.678,20.4002,21.333,22.0542,21.333C23.7082,21.333,25.0562,22.678,25.0562,24.333C25.0562,25.987,23.7082,27.332,22.0542,27.332 M30.6282,22.889L28.3522,22.889C28.1912,22.183,27.9142,21.516,27.5272,20.905L29.1392,19.293C29.3062,19.126,29.3062,18.853,29.1392,18.687L27.7032,17.251C27.6232,17.173,27.5152,17.125,27.3982,17.125C27.2862,17.125,27.1782,17.173,27.0952,17.251L25.4872,18.863C24.8732,18.476,24.2082,18.201,23.5002,18.038L23.5002,15.762C23.5002,15.525,23.3092,15.333,23.0732,15.333L21.0422,15.333C20.8062,15.333,20.6122,15.525,20.6122,15.762L20.6122,18.038C19.9072,18.201,19.2412,18.476,18.6292,18.863L17.0192,17.252C16.9342,17.168,16.8242,17.128,16.7162,17.128C16.6052,17.128,16.4972,17.168,16.4112,17.252L14.9752,18.687C14.8952,18.768,14.8492,18.878,14.8492,18.99C14.8492,19.104,14.8952,19.216,14.9752,19.293L16.5872,20.905C16.2002,21.516,15.9242,22.183,15.7642,22.889L13.4852,22.889C13.2502,22.889,13.0572,23.08,13.0572,23.316L13.0572,25.35C13.0572,25.584,13.2502,25.777,13.4852,25.777L15.7612,25.777C15.9242,26.486,16.2002,27.15,16.5872,27.764L14.9752,29.374C14.8092,29.538,14.8092,29.813,14.9752,29.979L16.4112,31.416C16.4912,31.494,16.6022,31.541,16.7162,31.541C16.8272,31.541,16.9382,31.494,17.0192,31.416L18.6252,29.805C19.2412,30.191,19.9072,30.467,20.6122,30.63L20.6122,32.906C20.6122,33.141,20.8062,33.333,21.0422,33.333L23.0732,33.333C23.3092,33.333,23.5002,33.141,23.5002,32.906L23.5002,30.63C24.2082,30.467,24.8732,30.191,25.4872,29.805L27.0952,31.416C27.1812,31.499,27.2892,31.541,27.3982,31.541C27.5102,31.541,27.6202,31.499,27.7032,31.416L29.1392,29.979C29.2202,29.899,29.2662,29.791,29.2662,29.677C29.2662,29.563,29.2202,29.453,29.1392,29.374L27.5312,27.764C27.9142,27.149,28.1912,26.486,28.3522,25.777L30.6282,25.777C30.8652,25.777,31.0552,25.584,31.0552,25.35L31.0552,23.316C31.0552,23.08,30.8652,22.889,30.6282,22.889";
    userHandles.push(settingHandle);
    return userHandles;


}

function OnChange(args) {
    var sliderValue = document.getElementsByClassName("sliderValue");
    for (var i = 0; i < sliderValue.length; i++)
        sliderValue[i].textContent = args.model.value + "%";
    if (args.id == "minSlider" && args.type == "change")
        $("#overviewSlider").ejSlider('option', 'value', args.value);
    else if (args.type == "change")
        $("#minSlider").ejSlider('option', 'value', args.value);
    $('#zoompercentage').ejDropDownList("option", "value", args.value + "%");
    var diagram = $("#DiagramContent").ejDiagram("instance");
    var zoom = ej.datavisualization.Diagram.Zoom();
    var value = args.value / 100;
    zoom.zoomFactor = value / diagram._getCurrentZoom();
    ej.datavisualization.Diagram.ZoomUtil.zoomPan(diagram, zoom.zoomFactor, 0, 0, zoom.focusPoint, true);

}
function OnCreate(args) {
    var sliderValue = document.getElementsByClassName("sliderValue");
    for (var i = 0; i < sliderValue.length; i++)
        sliderValue[i].textContent = args.model.value + "%";
}

function setDiagramWidth(args) {
    setDimension({ pageWidth: args.value })
};
function setDiagramHeight(args) {
    setDimension({ pageHeight: args.value })
};
function setDimension(obj) {
    var diagram = $("#DiagramContent").ejDiagram("instance");
    diagram.updatePageSettings(obj);
    var artBoardWidth = $("#artBoardWidth").data("ejNumericTextbox");
    var artBoardHeight = $("#artBoardHeight").data("ejNumericTextbox");
    artBoardWidth.option("value", diagram.model.pageSettings.pageWidth);
    artBoardHeight.option("value", diagram.model.pageSettings.pageHeight);
}
function setBackgroundColor(args) {
    var diagram = $("#DiagramContent").ejDiagram("instance");
    var bounds = diagram._getDigramBounds();
    var zoom = diagram._getCurrentZoom();
    var left = bounds.x * zoom;
    var top = bounds.y * zoom;
    var width = (bounds.width - bounds.x) * zoom;
    var height = (bounds.height - bounds.y) * zoom;
    var pageSettings = diagram.model.pageSettings;
    pageBackgroundColor = args.style.backgroundColor;
    document.getElementById("backgroundIcon").style.color = pageBackgroundColor;
    diagram.updatePageSettings({ "pageBackgroundColor": pageBackgroundColor });
}